{-# LANGUAGE MagicHash #-}
{-# LANGUAGE ScopedTypeVariables #-}
{-# OPTIONS_GHC -fno-warn-overlapping-patterns #-}

module AbstractCurry.Curry_Files
  ( d_C_readCurry
  , d_C_readCurryWithImports
  , d_C_tryReadCurryWithImports
  , d_C_tryReadCurryFile
  , d_C_tryParse
  , d_C_readUntypedCurry
  , d_C_readCurryWithParseOptions
  , d_C_readUntypedCurryWithParseOptions
  , d_C_abstractCurryFileName
  , d_C_untypedAbstractCurryFileName
  , d_C_readAbstractCurryFile
  , d_C_tryReadACYFile
  , d_C_writeAbstractCurryFile )
  where

import Basics
import qualified AbstractCurry.Curry_Select
import qualified AbstractCurry.Curry_Types
import qualified Curry_Char
import qualified Curry_Directory
import qualified Curry_Distribution
import qualified Curry_FileGoodies
import qualified Curry_FilePath
import qualified Curry_Maybe
import qualified Curry_Prelude
import qualified Curry_ReadShowTerm
import qualified Curry_Time


d_C_readCurry :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> Curry_Prelude.C_IO AbstractCurry.Curry_Types.C_CurryProg
d_C_readCurry x1 cd cs = d_C_readCurryWithParseOptions x1
  (Curry_Distribution.d_C_setQuiet Curry_Prelude.C_True
  (Curry_Distribution.d_C_defaultParams cd cs) cd cs) cd cs

d_C_readCurryWithImports :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CurryProg)
d_C_readCurryWithImports x1 cd cs = d_OP_readCurryWithImports_dot_collect_dot_4
  Curry_Prelude.OP_List (Curry_Prelude.OP_Cons x1 Curry_Prelude.OP_List) cd cs

d_OP_readCurryWithImports_dot_collect_dot_4 :: Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore
  -> Curry_Prelude.C_IO (Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CurryProg)
d_OP_readCurryWithImports_dot_collect_dot_4 x1 x2 cd cs = case x2 of
  Curry_Prelude.OP_List -> Curry_Prelude.d_C_return Curry_Prelude.OP_List cd cs
  Curry_Prelude.OP_Cons x3 x4 -> d_C__case_20 x1 x3 x4 (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_elem x3 cd cs) x1 cd cs) cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i
    (d_OP_readCurryWithImports_dot_collect_dot_4 x1 l cd cs)
    (d_OP_readCurryWithImports_dot_collect_dot_4 x1 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z ->
    d_OP_readCurryWithImports_dot_collect_dot_4 x1 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c
    (d_OP_readCurryWithImports_dot_collect_dot_4 x1 e cd $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "AbstractCurry.Files.readCurryWithImports.collect.4" [show x1, show x2]
    info)
  _ -> failCons cd (consFail
    "AbstractCurry.Files.readCurryWithImports.collect.4" (showCons x2))

d_OP_readCurryWithImports_dot_collect_dot_4_dot_uscore_hash_lambda1 :: Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> AbstractCurry.Curry_Types.C_CurryProg -> Cover
  -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CurryProg)
d_OP_readCurryWithImports_dot_collect_dot_4_dot_uscore_hash_lambda1 x1 x2 x3 x4 cd cs =
  Curry_Prelude.d_OP_gt_gt_eq (d_OP_readCurryWithImports_dot_collect_dot_4
  (Curry_Prelude.OP_Cons x2 x1) (Curry_Prelude.d_OP_plus_plus x3
  (AbstractCurry.Curry_Select.d_C_imports x4 cd cs) cd cs) cd cs)
  (d_OP_readCurryWithImports_dot_collect_dot_4_dot_uscore_hash_lambda1_dot_uscore_hash_lambda2
  x4) cd cs

d_OP_readCurryWithImports_dot_collect_dot_4_dot_uscore_hash_lambda1_dot_uscore_hash_lambda2 :: AbstractCurry.Curry_Types.C_CurryProg
  -> Curry_Prelude.OP_List AbstractCurry.Curry_Types.C_CurryProg -> Cover
  -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CurryProg)
d_OP_readCurryWithImports_dot_collect_dot_4_dot_uscore_hash_lambda1_dot_uscore_hash_lambda2 x1 x2 cd cs =
  Curry_Prelude.d_C_return (Curry_Prelude.OP_Cons x1 x2) cd cs

d_C_tryReadCurryWithImports :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Either
  (Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_List AbstractCurry.Curry_Types.C_CurryProg))
d_C_tryReadCurryWithImports x1 cd cs =
  d_OP_tryReadCurryWithImports_dot_collect_dot_13 Curry_Prelude.OP_List
  (Curry_Prelude.OP_Cons x1 Curry_Prelude.OP_List) cd cs

d_OP_tryReadCurryWithImports_dot_collect_dot_13 :: Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore
  -> Curry_Prelude.C_IO (Curry_Prelude.C_Either (Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CurryProg))
d_OP_tryReadCurryWithImports_dot_collect_dot_13 x1 x2 cd cs = case x2 of
  Curry_Prelude.OP_List -> Curry_Prelude.d_C_return (Curry_Prelude.C_Right
    Curry_Prelude.OP_List) cd cs
  Curry_Prelude.OP_Cons x3 x4 -> d_C__case_18 x1 x3 x4 (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_elem x3 cd cs) x1 cd cs) cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i
    (d_OP_tryReadCurryWithImports_dot_collect_dot_13 x1 l cd cs)
    (d_OP_tryReadCurryWithImports_dot_collect_dot_13 x1 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z ->
    d_OP_tryReadCurryWithImports_dot_collect_dot_13 x1 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c
    (d_OP_tryReadCurryWithImports_dot_collect_dot_13 x1 e cd $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "AbstractCurry.Files.tryReadCurryWithImports.collect.13" [show x1, show x2]
    info)
  _ -> failCons cd (consFail
    "AbstractCurry.Files.tryReadCurryWithImports.collect.13" (showCons x2))

d_OP_tryReadCurryWithImports_dot_collect_dot_13_dot_uscore_hash_lambda3 :: Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.C_Either (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) AbstractCurry.Curry_Types.C_CurryProg -> Cover
  -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Either
  (Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_List AbstractCurry.Curry_Types.C_CurryProg))
d_OP_tryReadCurryWithImports_dot_collect_dot_13_dot_uscore_hash_lambda3 x1 x2 x3 x4 cd cs =
  case x4 of
  Curry_Prelude.C_Left x5 -> Curry_Prelude.d_C_return (Curry_Prelude.C_Left
    (Curry_Prelude.OP_Cons x5 Curry_Prelude.OP_List)) cd cs
  Curry_Prelude.C_Right x6 -> d_C__case_16 x3 x1 x2 x6 cd cs
  Curry_Prelude.Choice_C_Either d i l r -> narrow d i
    (d_OP_tryReadCurryWithImports_dot_collect_dot_13_dot_uscore_hash_lambda3 x1
    x2 x3 l cd cs)
    (d_OP_tryReadCurryWithImports_dot_collect_dot_13_dot_uscore_hash_lambda3 x1
    x2 x3 r cd cs)
  Curry_Prelude.Choices_C_Either d i xs -> narrows cs d i (\z ->
    d_OP_tryReadCurryWithImports_dot_collect_dot_13_dot_uscore_hash_lambda3 x1
    x2 x3 z cd cs) xs
  Curry_Prelude.Guard_C_Either d c e -> guardCons d c
    (d_OP_tryReadCurryWithImports_dot_collect_dot_13_dot_uscore_hash_lambda3 x1
    x2 x3 e cd $! addCs c cs)
  Curry_Prelude.Fail_C_Either d info -> failCons d (traceFail
    "AbstractCurry.Files.tryReadCurryWithImports.collect.13._#lambda3" [show x1
    , show x2, show x3, show x4] info)
  _ -> failCons cd (consFail
    "AbstractCurry.Files.tryReadCurryWithImports.collect.13._#lambda3" (showCons
    x4))

d_OP_tryReadCurryWithImports_dot_collect_dot_13_dot_uscore_hash_lambda3_dot_uscore_hash_lambda5 :: AbstractCurry.Curry_Types.C_CurryProg
  -> Curry_Prelude.C_Either (Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CurryProg) -> Cover -> ConstStore
  -> Curry_Prelude.C_IO (Curry_Prelude.C_Either (Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CurryProg))
d_OP_tryReadCurryWithImports_dot_collect_dot_13_dot_uscore_hash_lambda3_dot_uscore_hash_lambda5 x1 x2 cd cs =
  Curry_Prelude.d_C_return (Curry_Prelude.d_C_either (acceptCs id
  Curry_Prelude.C_Left) (Curry_Prelude.d_OP_dot (acceptCs id
  Curry_Prelude.C_Right) (acceptCs id (Curry_Prelude.OP_Cons x1)) cd cs) x2 cd
  cs) cd cs

d_C_tryReadCurryFile :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Either
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  AbstractCurry.Curry_Types.C_CurryProg)
d_C_tryReadCurryFile x1 cd cs = Curry_Prelude.d_OP_gt_gt_eq
  (Curry_Distribution.d_C_lookupModuleSourceInLoadPath x1 cd cs)
  (d_OP_tryReadCurryFile_dot_uscore_hash_lambda6 x1) cd cs

d_OP_tryReadCurryFile_dot_cancel_dot_30 :: forall t0 t1 . (Curry_Prelude.Curry
  t0, Curry_Prelude.Curry t1) => t0 -> Cover -> ConstStore -> Curry_Prelude.C_IO
  (Curry_Prelude.C_Either t0 t1)
d_OP_tryReadCurryFile_dot_cancel_dot_30 x1 cd cs = Curry_Prelude.d_C_return
  (Curry_Prelude.C_Left x1) cd cs

d_OP_tryReadCurryFile_dot_uscore_hash_lambda6 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Maybe (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> Cover -> ConstStore -> Curry_Prelude.C_IO
  (Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  AbstractCurry.Curry_Types.C_CurryProg)
d_OP_tryReadCurryFile_dot_uscore_hash_lambda6 x1 x2 cd cs = case x2 of
  Curry_Prelude.C_Nothing -> Curry_Prelude.d_OP_dollar
    d_OP_tryReadCurryFile_dot_cancel_dot_30 (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "Source module '")
    (Curry_Prelude.d_OP_plus_plus x1 (Curry_Prelude.toCurryString "' not found")
    cd cs) cd cs) cd cs
  Curry_Prelude.C_Just x3 -> d_C__case_15 x1 x3 cd cs
  Curry_Prelude.Choice_C_Maybe d i l r -> narrow d i
    (d_OP_tryReadCurryFile_dot_uscore_hash_lambda6 x1 l cd cs)
    (d_OP_tryReadCurryFile_dot_uscore_hash_lambda6 x1 r cd cs)
  Curry_Prelude.Choices_C_Maybe d i xs -> narrows cs d i (\z ->
    d_OP_tryReadCurryFile_dot_uscore_hash_lambda6 x1 z cd cs) xs
  Curry_Prelude.Guard_C_Maybe d c e -> guardCons d c
    (d_OP_tryReadCurryFile_dot_uscore_hash_lambda6 x1 e cd $! addCs c cs)
  Curry_Prelude.Fail_C_Maybe d info -> failCons d (traceFail
    "AbstractCurry.Files.tryReadCurryFile._#lambda6" [show x1, show x2] info)
  _ -> failCons cd (consFail "AbstractCurry.Files.tryReadCurryFile._#lambda6"
    (showCons x2))

d_OP_tryReadCurryFile_dot_uscore_hash_lambda6_dot_uscore_hash_lambda8 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Maybe (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover
  -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Either
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  AbstractCurry.Curry_Types.C_CurryProg)
d_OP_tryReadCurryFile_dot_uscore_hash_lambda6_dot_uscore_hash_lambda8 x1 x2 x3 cd cs =
  case x3 of
  Curry_Prelude.C_Nothing -> Curry_Prelude.d_OP_dollar
    d_OP_tryReadCurryFile_dot_cancel_dot_30 (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "AbstractCurry module '")
    (Curry_Prelude.d_OP_plus_plus x1 (Curry_Prelude.toCurryString "' not found")
    cd cs) cd cs) cd cs
  Curry_Prelude.C_Just x4 -> Curry_Prelude.d_OP_gt_gt_eq
    (Curry_Directory.d_C_getModificationTime x2 cd cs)
    (d_OP_tryReadCurryFile_dot_uscore_hash_lambda6_dot_uscore_hash_lambda8_dot_uscore_hash_lambda10
    x4 x2) cd cs
  Curry_Prelude.Choice_C_Maybe d i l r -> narrow d i
    (d_OP_tryReadCurryFile_dot_uscore_hash_lambda6_dot_uscore_hash_lambda8 x1 x2
    l cd cs)
    (d_OP_tryReadCurryFile_dot_uscore_hash_lambda6_dot_uscore_hash_lambda8 x1 x2
    r cd cs)
  Curry_Prelude.Choices_C_Maybe d i xs -> narrows cs d i (\z ->
    d_OP_tryReadCurryFile_dot_uscore_hash_lambda6_dot_uscore_hash_lambda8 x1 x2
    z cd cs) xs
  Curry_Prelude.Guard_C_Maybe d c e -> guardCons d c
    (d_OP_tryReadCurryFile_dot_uscore_hash_lambda6_dot_uscore_hash_lambda8 x1 x2
    e cd $! addCs c cs)
  Curry_Prelude.Fail_C_Maybe d info -> failCons d (traceFail
    "AbstractCurry.Files.tryReadCurryFile._#lambda6._#lambda8" [show x1, show x2
    , show x3] info)
  _ -> failCons cd (consFail
    "AbstractCurry.Files.tryReadCurryFile._#lambda6._#lambda8" (showCons x3))

d_OP_tryReadCurryFile_dot_uscore_hash_lambda6_dot_uscore_hash_lambda8_dot_uscore_hash_lambda10 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Time.C_ClockTime -> Cover -> ConstStore -> Curry_Prelude.C_IO
  (Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  AbstractCurry.Curry_Types.C_CurryProg)
d_OP_tryReadCurryFile_dot_uscore_hash_lambda6_dot_uscore_hash_lambda8_dot_uscore_hash_lambda10 x1 x2 x3 cd cs =
  Curry_Prelude.d_OP_gt_gt_eq (Curry_Directory.d_C_getModificationTime x1 cd cs)
  (d_OP_tryReadCurryFile_dot_uscore_hash_lambda6_dot_uscore_hash_lambda8_dot_uscore_hash_lambda10_dot_uscore_hash_lambda11
  x3 x1 x2) cd cs

d_OP_tryReadCurryFile_dot_uscore_hash_lambda6_dot_uscore_hash_lambda8_dot_uscore_hash_lambda10_dot_uscore_hash_lambda11 :: Curry_Time.C_ClockTime
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Time.C_ClockTime -> Cover -> ConstStore
  -> Curry_Prelude.C_IO (Curry_Prelude.C_Either (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) AbstractCurry.Curry_Types.C_CurryProg)
d_OP_tryReadCurryFile_dot_uscore_hash_lambda6_dot_uscore_hash_lambda8_dot_uscore_hash_lambda10_dot_uscore_hash_lambda11 x1 x2 x3 x4 cd cs =
  d_C__case_14 x4 x1 x2 x3 (Curry_Prelude.d_OP_gt x1 x4 cd cs) cd cs

d_OP_tryReadCurryFile_dot_uscore_hash_lambda6_dot_uscore_hash_lambda8_dot_uscore_hash_lambda10_dot_uscore_hash_lambda11_dot_uscore_hash_lambda12 :: Curry_Prelude.C_Either
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  AbstractCurry.Curry_Types.C_CurryProg -> Cover -> ConstStore
  -> Curry_Prelude.C_IO (Curry_Prelude.C_Either (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) AbstractCurry.Curry_Types.C_CurryProg)
d_OP_tryReadCurryFile_dot_uscore_hash_lambda6_dot_uscore_hash_lambda8_dot_uscore_hash_lambda10_dot_uscore_hash_lambda11_dot_uscore_hash_lambda12 x1 cd cs =
  case x1 of
  Curry_Prelude.C_Left x2 -> d_OP_tryReadCurryFile_dot_cancel_dot_30 x2 cd cs
  Curry_Prelude.C_Right x3 -> Curry_Prelude.d_C_return (Curry_Prelude.C_Right
    x3) cd cs
  Curry_Prelude.Choice_C_Either d i l r -> narrow d i
    (d_OP_tryReadCurryFile_dot_uscore_hash_lambda6_dot_uscore_hash_lambda8_dot_uscore_hash_lambda10_dot_uscore_hash_lambda11_dot_uscore_hash_lambda12
    l cd cs)
    (d_OP_tryReadCurryFile_dot_uscore_hash_lambda6_dot_uscore_hash_lambda8_dot_uscore_hash_lambda10_dot_uscore_hash_lambda11_dot_uscore_hash_lambda12
    r cd cs)
  Curry_Prelude.Choices_C_Either d i xs -> narrows cs d i (\z ->
    d_OP_tryReadCurryFile_dot_uscore_hash_lambda6_dot_uscore_hash_lambda8_dot_uscore_hash_lambda10_dot_uscore_hash_lambda11_dot_uscore_hash_lambda12
    z cd cs) xs
  Curry_Prelude.Guard_C_Either d c e -> guardCons d c
    (d_OP_tryReadCurryFile_dot_uscore_hash_lambda6_dot_uscore_hash_lambda8_dot_uscore_hash_lambda10_dot_uscore_hash_lambda11_dot_uscore_hash_lambda12
    e cd $! addCs c cs)
  Curry_Prelude.Fail_C_Either d info -> failCons d (traceFail
    "AbstractCurry.Files.tryReadCurryFile._#lambda6._#lambda8._#lambda10._#lambda11._#lambda12"
    [show x1] info)
  _ -> failCons cd (consFail
    "AbstractCurry.Files.tryReadCurryFile._#lambda6._#lambda8._#lambda10._#lambda11._#lambda12"
    (showCons x1))

d_C_tryParse :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Either
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  AbstractCurry.Curry_Types.C_CurryProg)
d_C_tryParse x1 cd cs = Curry_Prelude.d_OP_gt_gt_eq
  (Curry_Directory.d_C_doesFileExist x1 cd cs)
  (d_OP_tryParse_dot_uscore_hash_lambda14 x1) cd cs

d_OP_tryParse_dot_cancel_dot_52 :: forall t0 t1 . (Curry_Prelude.Curry t0
  , Curry_Prelude.Curry t1) => t0 -> Cover -> ConstStore -> Curry_Prelude.C_IO
  (Curry_Prelude.C_Either t0 t1)
d_OP_tryParse_dot_cancel_dot_52 x1 cd cs = Curry_Prelude.d_C_return
  (Curry_Prelude.C_Left x1) cd cs

d_OP_tryParse_dot_uscore_hash_lambda14 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.C_IO (Curry_Prelude.C_Either (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) AbstractCurry.Curry_Types.C_CurryProg)
d_OP_tryParse_dot_uscore_hash_lambda14 x1 x2 cd cs = d_C__case_13 x2 x1
  (Curry_Prelude.d_C_not x2 cd cs) cd cs

d_OP_tryParse_dot_uscore_hash_lambda14_dot_uscore_hash_lambda15 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Either
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  AbstractCurry.Curry_Types.C_CurryProg)
d_OP_tryParse_dot_uscore_hash_lambda14_dot_uscore_hash_lambda15 x1 x2 cd cs =
  let x3 = Curry_Prelude.d_C_apply (Curry_Prelude.d_C_break
        (Curry_Prelude.d_C_flip (acceptCs id Curry_Prelude.d_OP_eq_eq)
        (Curry_Prelude.C_Char '\n'#)) cd cs) x2 cd cs
      x4 = d_OP_tryParse_dot_uscore_hash_lambda14_dot_uscore_hash_lambda15_dot_uscore_hash_selFP2_hash_line1
        x3 cd cs
      x5 = d_OP_tryParse_dot_uscore_hash_lambda14_dot_uscore_hash_lambda15_dot_uscore_hash_selFP3_hash_lines
        x3 cd cs
  in d_C__case_12 x4 x5 x1 (Curry_Prelude.d_OP_slash_eq x4
  (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString "{- ")
  (Curry_Prelude.d_OP_plus_plus (AbstractCurry.Curry_Types.d_C_version cd cs)
  (Curry_Prelude.toCurryString " -}") cd cs) cd cs) cd cs) cd cs

d_OP_tryParse_dot_uscore_hash_lambda14_dot_uscore_hash_lambda15_dot_uscore_hash_selFP2_hash_line1 :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_OP_tryParse_dot_uscore_hash_lambda14_dot_uscore_hash_lambda15_dot_uscore_hash_selFP2_hash_line1 x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x2
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_tryParse_dot_uscore_hash_lambda14_dot_uscore_hash_lambda15_dot_uscore_hash_selFP2_hash_line1
    l cd cs)
    (d_OP_tryParse_dot_uscore_hash_lambda14_dot_uscore_hash_lambda15_dot_uscore_hash_selFP2_hash_line1
    r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_tryParse_dot_uscore_hash_lambda14_dot_uscore_hash_lambda15_dot_uscore_hash_selFP2_hash_line1
    z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (d_OP_tryParse_dot_uscore_hash_lambda14_dot_uscore_hash_lambda15_dot_uscore_hash_selFP2_hash_line1
    e cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "AbstractCurry.Files.tryParse._#lambda14._#lambda15._#selFP2#line1" [show
    x1] info)
  _ -> failCons cd (consFail
    "AbstractCurry.Files.tryParse._#lambda14._#lambda15._#selFP2#line1"
    (showCons x1))

d_OP_tryParse_dot_uscore_hash_lambda14_dot_uscore_hash_lambda15_dot_uscore_hash_selFP3_hash_lines :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_OP_tryParse_dot_uscore_hash_lambda14_dot_uscore_hash_lambda15_dot_uscore_hash_selFP3_hash_lines x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x3
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_tryParse_dot_uscore_hash_lambda14_dot_uscore_hash_lambda15_dot_uscore_hash_selFP3_hash_lines
    l cd cs)
    (d_OP_tryParse_dot_uscore_hash_lambda14_dot_uscore_hash_lambda15_dot_uscore_hash_selFP3_hash_lines
    r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_tryParse_dot_uscore_hash_lambda14_dot_uscore_hash_lambda15_dot_uscore_hash_selFP3_hash_lines
    z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (d_OP_tryParse_dot_uscore_hash_lambda14_dot_uscore_hash_lambda15_dot_uscore_hash_selFP3_hash_lines
    e cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "AbstractCurry.Files.tryParse._#lambda14._#lambda15._#selFP3#lines" [show
    x1] info)
  _ -> failCons cd (consFail
    "AbstractCurry.Files.tryParse._#lambda14._#lambda15._#selFP3#lines"
    (showCons x1))

d_C_readUntypedCurry :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> Curry_Prelude.C_IO AbstractCurry.Curry_Types.C_CurryProg
d_C_readUntypedCurry x1 cd cs = d_C_readUntypedCurryWithParseOptions x1
  (Curry_Distribution.d_C_setQuiet Curry_Prelude.C_True
  (Curry_Distribution.d_C_defaultParams cd cs) cd cs) cd cs

d_C_readCurryWithParseOptions :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Distribution.C_FrontendParams -> Cover -> ConstStore
  -> Curry_Prelude.C_IO AbstractCurry.Curry_Types.C_CurryProg
d_C_readCurryWithParseOptions x1 x2 cd cs = let x3 = Curry_Prelude.d_C_apply
                                                  (Curry_FilePath.d_C_takeFileName
                                                  cd cs) x1 cd cs
  in Curry_Prelude.d_OP_gt_gt_eq
  (Curry_Distribution.d_C_lookupModuleSourceInLoadPath x1 cd cs)
  (d_OP_readCurryWithParseOptions_dot_uscore_hash_lambda18 x3 x2 x1) cd cs

d_OP_readCurryWithParseOptions_dot_uscore_hash_lambda18 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Distribution.C_FrontendParams
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Maybe
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Cover -> ConstStore
  -> Curry_Prelude.C_IO AbstractCurry.Curry_Types.C_CurryProg
d_OP_readCurryWithParseOptions_dot_uscore_hash_lambda18 x1 x2 x3 x4 cd cs =
  case x4 of
  Curry_Prelude.C_Nothing -> Curry_Prelude.d_OP_gt_gt_eq
    (Curry_Distribution.d_C_getLoadPathForModule x3 cd cs)
    (d_OP_readCurryWithParseOptions_dot_uscore_hash_lambda18_dot_uscore_hash_lambda20
    x1) cd cs
  Curry_Prelude.C_Just x5 -> d_C__case_7 x1 x3 x2 x5 cd cs
  Curry_Prelude.Choice_C_Maybe d i l r -> narrow d i
    (d_OP_readCurryWithParseOptions_dot_uscore_hash_lambda18 x1 x2 x3 l cd cs)
    (d_OP_readCurryWithParseOptions_dot_uscore_hash_lambda18 x1 x2 x3 r cd cs)
  Curry_Prelude.Choices_C_Maybe d i xs -> narrows cs d i (\z ->
    d_OP_readCurryWithParseOptions_dot_uscore_hash_lambda18 x1 x2 x3 z cd cs) xs
  Curry_Prelude.Guard_C_Maybe d c e -> guardCons d c
    (d_OP_readCurryWithParseOptions_dot_uscore_hash_lambda18 x1 x2 x3 e cd $!
    addCs c cs)
  Curry_Prelude.Fail_C_Maybe d info -> failCons d (traceFail
    "AbstractCurry.Files.readCurryWithParseOptions._#lambda18" [show x1, show x2
    , show x3, show x4] info)
  _ -> failCons cd (consFail
    "AbstractCurry.Files.readCurryWithParseOptions._#lambda18" (showCons x4))

d_OP_readCurryWithParseOptions_dot_uscore_hash_lambda18_dot_uscore_hash_lambda20 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.C_IO
  AbstractCurry.Curry_Types.C_CurryProg
d_OP_readCurryWithParseOptions_dot_uscore_hash_lambda18_dot_uscore_hash_lambda20 x1 x2 cd cs =
  Curry_Prelude.d_OP_gt_gt_eq (Curry_FileGoodies.d_C_getFileInPath
  (d_C_abstractCurryFileName x1 cd cs) (Curry_Prelude.OP_Cons
  Curry_Prelude.OP_List Curry_Prelude.OP_List) x2 cd cs)
  d_OP_readCurryWithParseOptions_dot_uscore_hash_lambda18_dot_uscore_hash_lambda20_dot_uscore_hash_lambda21
  cd cs

d_OP_readCurryWithParseOptions_dot_uscore_hash_lambda18_dot_uscore_hash_lambda20_dot_uscore_hash_lambda21 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO
  AbstractCurry.Curry_Types.C_CurryProg
d_OP_readCurryWithParseOptions_dot_uscore_hash_lambda18_dot_uscore_hash_lambda20_dot_uscore_hash_lambda21 x1 cd cs =
  d_C_readAbstractCurryFile x1 cd cs

d_C_readUntypedCurryWithParseOptions :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Distribution.C_FrontendParams -> Cover
  -> ConstStore -> Curry_Prelude.C_IO AbstractCurry.Curry_Types.C_CurryProg
d_C_readUntypedCurryWithParseOptions x1 x2 cd cs =
  let x3 = Curry_Prelude.d_C_apply (Curry_FilePath.d_C_takeFileName cd cs) x1 cd
        cs
  in Curry_Prelude.d_OP_gt_gt_eq
  (Curry_Distribution.d_C_lookupModuleSourceInLoadPath x1 cd cs)
  (d_OP_readUntypedCurryWithParseOptions_dot_uscore_hash_lambda22 x3 x2 x1) cd
  cs

d_OP_readUntypedCurryWithParseOptions_dot_uscore_hash_lambda22 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Distribution.C_FrontendParams
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Maybe
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Cover -> ConstStore
  -> Curry_Prelude.C_IO AbstractCurry.Curry_Types.C_CurryProg
d_OP_readUntypedCurryWithParseOptions_dot_uscore_hash_lambda22 x1 x2 x3 x4 cd cs =
  case x4 of
  Curry_Prelude.C_Nothing -> Curry_Prelude.d_OP_gt_gt_eq
    (Curry_Distribution.d_C_getLoadPathForModule x3 cd cs)
    (d_OP_readUntypedCurryWithParseOptions_dot_uscore_hash_lambda22_dot_uscore_hash_lambda24
    x1) cd cs
  Curry_Prelude.C_Just x5 -> d_C__case_6 x1 x3 x2 x5 cd cs
  Curry_Prelude.Choice_C_Maybe d i l r -> narrow d i
    (d_OP_readUntypedCurryWithParseOptions_dot_uscore_hash_lambda22 x1 x2 x3 l
    cd cs) (d_OP_readUntypedCurryWithParseOptions_dot_uscore_hash_lambda22 x1 x2
    x3 r cd cs)
  Curry_Prelude.Choices_C_Maybe d i xs -> narrows cs d i (\z ->
    d_OP_readUntypedCurryWithParseOptions_dot_uscore_hash_lambda22 x1 x2 x3 z cd
    cs) xs
  Curry_Prelude.Guard_C_Maybe d c e -> guardCons d c
    (d_OP_readUntypedCurryWithParseOptions_dot_uscore_hash_lambda22 x1 x2 x3 e
    cd $! addCs c cs)
  Curry_Prelude.Fail_C_Maybe d info -> failCons d (traceFail
    "AbstractCurry.Files.readUntypedCurryWithParseOptions._#lambda22" [show x1
    , show x2, show x3, show x4] info)
  _ -> failCons cd (consFail
    "AbstractCurry.Files.readUntypedCurryWithParseOptions._#lambda22" (showCons
    x4))

d_OP_readUntypedCurryWithParseOptions_dot_uscore_hash_lambda22_dot_uscore_hash_lambda24 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.C_IO
  AbstractCurry.Curry_Types.C_CurryProg
d_OP_readUntypedCurryWithParseOptions_dot_uscore_hash_lambda22_dot_uscore_hash_lambda24 x1 x2 cd cs =
  Curry_Prelude.d_OP_gt_gt_eq (Curry_FileGoodies.d_C_getFileInPath
  (d_C_untypedAbstractCurryFileName x1 cd cs) (Curry_Prelude.OP_Cons
  Curry_Prelude.OP_List Curry_Prelude.OP_List) x2 cd cs)
  d_OP_readUntypedCurryWithParseOptions_dot_uscore_hash_lambda22_dot_uscore_hash_lambda24_dot_uscore_hash_lambda25
  cd cs

d_OP_readUntypedCurryWithParseOptions_dot_uscore_hash_lambda22_dot_uscore_hash_lambda24_dot_uscore_hash_lambda25 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO
  AbstractCurry.Curry_Types.C_CurryProg
d_OP_readUntypedCurryWithParseOptions_dot_uscore_hash_lambda22_dot_uscore_hash_lambda24_dot_uscore_hash_lambda25 x1 cd cs =
  d_C_readAbstractCurryFile x1 cd cs

d_C_abstractCurryFileName :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_abstractCurryFileName x1 cd cs = Curry_Prelude.d_C_apply
  (Curry_Prelude.d_C_apply (Curry_FilePath.d_OP_lt_dot_gt cd cs)
  (Curry_Distribution.d_C_inCurrySubdir (Curry_Distribution.d_C_stripCurrySuffix
  x1 cd cs) cd cs) cd cs) (Curry_Prelude.toCurryString "acy") cd cs

d_C_untypedAbstractCurryFileName :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_untypedAbstractCurryFileName x1 cd cs = Curry_Prelude.d_C_apply
  (Curry_Prelude.d_C_apply (Curry_FilePath.d_OP_lt_dot_gt cd cs)
  (Curry_Distribution.d_C_inCurrySubdir (Curry_Distribution.d_C_stripCurrySuffix
  x1 cd cs) cd cs) cd cs) (Curry_Prelude.toCurryString "uacy") cd cs

d_C_readAbstractCurryFile :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> Curry_Prelude.C_IO AbstractCurry.Curry_Types.C_CurryProg
d_C_readAbstractCurryFile x1 cd cs = Curry_Prelude.d_OP_gt_gt_eq
  (Curry_Directory.d_C_doesFileExist x1 cd cs)
  (d_OP_readAbstractCurryFile_dot_uscore_hash_lambda27 x1) cd cs

d_OP_readAbstractCurryFile_dot_readExistingACY_dot_95 :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.C_IO t0
d_OP_readAbstractCurryFile_dot_readExistingACY_dot_95 x1 cd cs =
  Curry_Prelude.d_OP_gt_gt_eq (Curry_Prelude.d_C_readFile x1 cd cs)
  (d_OP_readAbstractCurryFile_dot_readExistingACY_dot_95_dot_uscore_hash_lambda26
  x1) cd cs

d_OP_readAbstractCurryFile_dot_readExistingACY_dot_95_dot_uscore_hash_lambda26 :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO t0
d_OP_readAbstractCurryFile_dot_readExistingACY_dot_95_dot_uscore_hash_lambda26 x1 x2 cd cs =
  let x3 = Curry_Prelude.d_C_apply (Curry_Prelude.d_C_break
        (Curry_Prelude.d_C_flip (acceptCs id Curry_Prelude.d_OP_eq_eq)
        (Curry_Prelude.C_Char '\n'#)) cd cs) x2 cd cs
      x4 = d_OP_readAbstractCurryFile_dot_readExistingACY_dot_95_dot_uscore_hash_lambda26_dot_uscore_hash_selFP5_hash_line1
        x3 cd cs
      x5 = d_OP_readAbstractCurryFile_dot_readExistingACY_dot_95_dot_uscore_hash_lambda26_dot_uscore_hash_selFP6_hash_lines
        x3 cd cs
  in d_C__case_5 x4 x1 x5 (Curry_Prelude.d_OP_eq_eq x4
  (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString "{- ")
  (Curry_Prelude.d_OP_plus_plus (AbstractCurry.Curry_Types.d_C_version cd cs)
  (Curry_Prelude.toCurryString " -}") cd cs) cd cs) cd cs) cd cs

d_OP_readAbstractCurryFile_dot_readExistingACY_dot_95_dot_uscore_hash_lambda26_dot_uscore_hash_selFP5_hash_line1 :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_OP_readAbstractCurryFile_dot_readExistingACY_dot_95_dot_uscore_hash_lambda26_dot_uscore_hash_selFP5_hash_line1 x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x2
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_readAbstractCurryFile_dot_readExistingACY_dot_95_dot_uscore_hash_lambda26_dot_uscore_hash_selFP5_hash_line1
    l cd cs)
    (d_OP_readAbstractCurryFile_dot_readExistingACY_dot_95_dot_uscore_hash_lambda26_dot_uscore_hash_selFP5_hash_line1
    r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_readAbstractCurryFile_dot_readExistingACY_dot_95_dot_uscore_hash_lambda26_dot_uscore_hash_selFP5_hash_line1
    z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (d_OP_readAbstractCurryFile_dot_readExistingACY_dot_95_dot_uscore_hash_lambda26_dot_uscore_hash_selFP5_hash_line1
    e cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "AbstractCurry.Files.readAbstractCurryFile.readExistingACY.95._#lambda26._#selFP5#line1"
    [show x1] info)
  _ -> failCons cd (consFail
    "AbstractCurry.Files.readAbstractCurryFile.readExistingACY.95._#lambda26._#selFP5#line1"
    (showCons x1))

d_OP_readAbstractCurryFile_dot_readExistingACY_dot_95_dot_uscore_hash_lambda26_dot_uscore_hash_selFP6_hash_lines :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_OP_readAbstractCurryFile_dot_readExistingACY_dot_95_dot_uscore_hash_lambda26_dot_uscore_hash_selFP6_hash_lines x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x3
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_readAbstractCurryFile_dot_readExistingACY_dot_95_dot_uscore_hash_lambda26_dot_uscore_hash_selFP6_hash_lines
    l cd cs)
    (d_OP_readAbstractCurryFile_dot_readExistingACY_dot_95_dot_uscore_hash_lambda26_dot_uscore_hash_selFP6_hash_lines
    r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_readAbstractCurryFile_dot_readExistingACY_dot_95_dot_uscore_hash_lambda26_dot_uscore_hash_selFP6_hash_lines
    z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (d_OP_readAbstractCurryFile_dot_readExistingACY_dot_95_dot_uscore_hash_lambda26_dot_uscore_hash_selFP6_hash_lines
    e cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "AbstractCurry.Files.readAbstractCurryFile.readExistingACY.95._#lambda26._#selFP6#lines"
    [show x1] info)
  _ -> failCons cd (consFail
    "AbstractCurry.Files.readAbstractCurryFile.readExistingACY.95._#lambda26._#selFP6#lines"
    (showCons x1))

d_OP_readAbstractCurryFile_dot_uscore_hash_lambda27 :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Bool
  -> Cover -> ConstStore -> Curry_Prelude.C_IO t0
d_OP_readAbstractCurryFile_dot_uscore_hash_lambda27 x1 x2 cd cs = case x2 of
  Curry_Prelude.C_True -> d_OP_readAbstractCurryFile_dot_readExistingACY_dot_95
    x1 cd cs
  Curry_Prelude.C_False -> let x3 = Curry_Distribution.d_C_inCurrySubdir x1 cd
                                 cs
    in Curry_Prelude.d_OP_gt_gt_eq (Curry_Directory.d_C_doesFileExist x3 cd cs)
    (d_OP_readAbstractCurryFile_dot_uscore_hash_lambda27_dot_uscore_hash_lambda28
    x1 x3) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i
    (d_OP_readAbstractCurryFile_dot_uscore_hash_lambda27 x1 l cd cs)
    (d_OP_readAbstractCurryFile_dot_uscore_hash_lambda27 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z ->
    d_OP_readAbstractCurryFile_dot_uscore_hash_lambda27 x1 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c
    (d_OP_readAbstractCurryFile_dot_uscore_hash_lambda27 x1 e cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "AbstractCurry.Files.readAbstractCurryFile._#lambda27" [show x1, show x2]
    info)
  _ -> failCons cd (consFail
    "AbstractCurry.Files.readAbstractCurryFile._#lambda27" (showCons x2))

d_OP_readAbstractCurryFile_dot_uscore_hash_lambda27_dot_uscore_hash_lambda28 :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.C_IO t0
d_OP_readAbstractCurryFile_dot_uscore_hash_lambda27_dot_uscore_hash_lambda28 x1 x2 x3 cd cs =
  case x3 of
  Curry_Prelude.C_True -> d_OP_readAbstractCurryFile_dot_readExistingACY_dot_95
    x2 cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_error (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "EXISTENCE ERROR: AbstractCurry file '")
    (Curry_Prelude.d_OP_plus_plus x1 (Curry_Prelude.toCurryString
    "' does not exist") cd cs) cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i
    (d_OP_readAbstractCurryFile_dot_uscore_hash_lambda27_dot_uscore_hash_lambda28
    x1 x2 l cd cs)
    (d_OP_readAbstractCurryFile_dot_uscore_hash_lambda27_dot_uscore_hash_lambda28
    x1 x2 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z ->
    d_OP_readAbstractCurryFile_dot_uscore_hash_lambda27_dot_uscore_hash_lambda28
    x1 x2 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c
    (d_OP_readAbstractCurryFile_dot_uscore_hash_lambda27_dot_uscore_hash_lambda28
    x1 x2 e cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "AbstractCurry.Files.readAbstractCurryFile._#lambda27._#lambda28" [show x1
    , show x2, show x3] info)
  _ -> failCons cd (consFail
    "AbstractCurry.Files.readAbstractCurryFile._#lambda27._#lambda28" (showCons
    x3))

d_C_tryReadACYFile :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe
  AbstractCurry.Curry_Types.C_CurryProg)
d_C_tryReadACYFile x1 cd cs = let x2 = Curry_Prelude.d_C_return
                                    Curry_Prelude.C_Nothing cd cs
  in Curry_Prelude.d_OP_gt_gt_eq (Curry_Directory.d_C_doesFileExist x1 cd cs)
  (d_OP_tryReadACYFile_dot_uscore_hash_lambda31 x2 x1) cd cs

d_OP_tryReadACYFile_dot_tryRead_dot_106 :: Curry_Prelude.C_IO
  (Curry_Prelude.C_Maybe AbstractCurry.Curry_Types.C_CurryProg)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO
  (Curry_Prelude.C_Maybe AbstractCurry.Curry_Types.C_CurryProg)
d_OP_tryReadACYFile_dot_tryRead_dot_106 x1 x2 x3 cd cs =
  Curry_Prelude.d_OP_gt_gt_eq (Curry_Prelude.d_C_readFile x3 cd cs)
  (d_OP_tryReadACYFile_dot_tryRead_dot_106_dot_uscore_hash_lambda29 x1 x2) cd cs

nd_OP_tryReadACYFile_dot_tryRead_dot_106 :: Curry_Prelude.C_IO
  (Curry_Prelude.C_Maybe AbstractCurry.Curry_Types.C_CurryProg)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_IO
  (Curry_Prelude.C_Maybe AbstractCurry.Curry_Types.C_CurryProg)
nd_OP_tryReadACYFile_dot_tryRead_dot_106 x1 x2 x3 s cd cs = let s0 = s
  in s0 `seq` Curry_Prelude.nd_OP_gt_gt_eq (Curry_Prelude.d_C_readFile x3 cd cs)
  (wrapNX id (nd_OP_tryReadACYFile_dot_tryRead_dot_106_dot_uscore_hash_lambda29
  x1 x2)) s0 cd cs

d_OP_tryReadACYFile_dot_tryRead_dot_106_dot_uscore_hash_lambda29 :: Curry_Prelude.C_IO
  (Curry_Prelude.C_Maybe AbstractCurry.Curry_Types.C_CurryProg)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO
  (Curry_Prelude.C_Maybe AbstractCurry.Curry_Types.C_CurryProg)
d_OP_tryReadACYFile_dot_tryRead_dot_106_dot_uscore_hash_lambda29 x1 x2 x3 cd cs =
  let x4 = Curry_Prelude.d_C_apply (Curry_Prelude.d_C_break
        (Curry_Prelude.d_C_flip (acceptCs id Curry_Prelude.d_OP_eq_eq)
        (Curry_Prelude.C_Char '\n'#)) cd cs) x3 cd cs
      x5 = d_OP_tryReadACYFile_dot_tryRead_dot_106_dot_uscore_hash_lambda29_dot_uscore_hash_selFP8_hash_line1
        x4 cd cs
      x6 = d_OP_tryReadACYFile_dot_tryRead_dot_106_dot_uscore_hash_lambda29_dot_uscore_hash_selFP9_hash_lines
        x4 cd cs
  in d_C__case_4 x5 x6 x1 x2 (Curry_Prelude.d_OP_slash_eq x5
  (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString "{- ")
  (Curry_Prelude.d_OP_plus_plus (AbstractCurry.Curry_Types.d_C_version cd cs)
  (Curry_Prelude.toCurryString " -}") cd cs) cd cs) cd cs) cd cs

nd_OP_tryReadACYFile_dot_tryRead_dot_106_dot_uscore_hash_lambda29 :: Curry_Prelude.C_IO
  (Curry_Prelude.C_Maybe AbstractCurry.Curry_Types.C_CurryProg)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_IO
  (Curry_Prelude.C_Maybe AbstractCurry.Curry_Types.C_CurryProg)
nd_OP_tryReadACYFile_dot_tryRead_dot_106_dot_uscore_hash_lambda29 x1 x2 x3 s cd cs =
  let s4 = s
  in s4 `seq` (let s2 = leftSupply s4
                   s3 = rightSupply s4
  in s2 `seq` (s3 `seq` (let x4 = let s1 = leftSupply s2
                                      s0 = rightSupply s2
                               in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply
                               (Curry_Prelude.nd_C_break (wrapNX id
                               (Curry_Prelude.nd_C_flip (wrapDX (wrapDX id)
                               (acceptCs id Curry_Prelude.d_OP_eq_eq))
                               (Curry_Prelude.C_Char '\n'#))) s0 cd cs) x3 s1 cd
                               cs)
                             x5 = d_OP_tryReadACYFile_dot_tryRead_dot_106_dot_uscore_hash_lambda29_dot_uscore_hash_selFP8_hash_line1
                               x4 cd cs
                             x6 = d_OP_tryReadACYFile_dot_tryRead_dot_106_dot_uscore_hash_lambda29_dot_uscore_hash_selFP9_hash_lines
                               x4 cd cs
  in nd_C__case_4 x5 x6 x1 x2 (Curry_Prelude.d_OP_slash_eq x5
  (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString "{- ")
  (Curry_Prelude.d_OP_plus_plus (AbstractCurry.Curry_Types.d_C_version cd cs)
  (Curry_Prelude.toCurryString " -}") cd cs) cd cs) cd cs) s3 cd cs)))

d_OP_tryReadACYFile_dot_tryRead_dot_106_dot_uscore_hash_lambda29_dot_uscore_hash_selFP8_hash_line1 :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_OP_tryReadACYFile_dot_tryRead_dot_106_dot_uscore_hash_lambda29_dot_uscore_hash_selFP8_hash_line1 x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x2
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_tryReadACYFile_dot_tryRead_dot_106_dot_uscore_hash_lambda29_dot_uscore_hash_selFP8_hash_line1
    l cd cs)
    (d_OP_tryReadACYFile_dot_tryRead_dot_106_dot_uscore_hash_lambda29_dot_uscore_hash_selFP8_hash_line1
    r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_tryReadACYFile_dot_tryRead_dot_106_dot_uscore_hash_lambda29_dot_uscore_hash_selFP8_hash_line1
    z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (d_OP_tryReadACYFile_dot_tryRead_dot_106_dot_uscore_hash_lambda29_dot_uscore_hash_selFP8_hash_line1
    e cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "AbstractCurry.Files.tryReadACYFile.tryRead.106._#lambda29._#selFP8#line1"
    [show x1] info)
  _ -> failCons cd (consFail
    "AbstractCurry.Files.tryReadACYFile.tryRead.106._#lambda29._#selFP8#line1"
    (showCons x1))

d_OP_tryReadACYFile_dot_tryRead_dot_106_dot_uscore_hash_lambda29_dot_uscore_hash_selFP9_hash_lines :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_OP_tryReadACYFile_dot_tryRead_dot_106_dot_uscore_hash_lambda29_dot_uscore_hash_selFP9_hash_lines x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x3
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_tryReadACYFile_dot_tryRead_dot_106_dot_uscore_hash_lambda29_dot_uscore_hash_selFP9_hash_lines
    l cd cs)
    (d_OP_tryReadACYFile_dot_tryRead_dot_106_dot_uscore_hash_lambda29_dot_uscore_hash_selFP9_hash_lines
    r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_tryReadACYFile_dot_tryRead_dot_106_dot_uscore_hash_lambda29_dot_uscore_hash_selFP9_hash_lines
    z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (d_OP_tryReadACYFile_dot_tryRead_dot_106_dot_uscore_hash_lambda29_dot_uscore_hash_selFP9_hash_lines
    e cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "AbstractCurry.Files.tryReadACYFile.tryRead.106._#lambda29._#selFP9#lines"
    [show x1] info)
  _ -> failCons cd (consFail
    "AbstractCurry.Files.tryReadACYFile.tryRead.106._#lambda29._#selFP9#lines"
    (showCons x1))

d_OP_tryReadACYFile_dot_uscore_hash_lambda31 :: Curry_Prelude.C_IO
  (Curry_Prelude.C_Maybe AbstractCurry.Curry_Types.C_CurryProg)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe
  AbstractCurry.Curry_Types.C_CurryProg)
d_OP_tryReadACYFile_dot_uscore_hash_lambda31 x1 x2 x3 cd cs = case x3 of
  Curry_Prelude.C_True -> d_OP_tryReadACYFile_dot_tryRead_dot_106 x1 x2 x2 cd cs
  Curry_Prelude.C_False -> let x4 = Curry_Distribution.d_C_inCurrySubdir x2 cd
                                 cs
    in Curry_Prelude.d_OP_gt_gt_eq (Curry_Directory.d_C_doesFileExist x4 cd cs)
    (d_OP_tryReadACYFile_dot_uscore_hash_lambda31_dot_uscore_hash_lambda32 x1 x2
    x4) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i
    (d_OP_tryReadACYFile_dot_uscore_hash_lambda31 x1 x2 l cd cs)
    (d_OP_tryReadACYFile_dot_uscore_hash_lambda31 x1 x2 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z ->
    d_OP_tryReadACYFile_dot_uscore_hash_lambda31 x1 x2 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c
    (d_OP_tryReadACYFile_dot_uscore_hash_lambda31 x1 x2 e cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "AbstractCurry.Files.tryReadACYFile._#lambda31" [show x1, show x2, show x3]
    info)
  _ -> failCons cd (consFail "AbstractCurry.Files.tryReadACYFile._#lambda31"
    (showCons x3))

nd_OP_tryReadACYFile_dot_uscore_hash_lambda31 :: Curry_Prelude.C_IO
  (Curry_Prelude.C_Maybe AbstractCurry.Curry_Types.C_CurryProg)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Bool
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_IO
  (Curry_Prelude.C_Maybe AbstractCurry.Curry_Types.C_CurryProg)
nd_OP_tryReadACYFile_dot_uscore_hash_lambda31 x1 x2 x3 s cd cs = case x3 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` nd_OP_tryReadACYFile_dot_tryRead_dot_106 x1 x2 x2 s0 cd cs
  Curry_Prelude.C_False -> let s0 = s
    in s0 `seq` (let x4 = Curry_Distribution.d_C_inCurrySubdir x2 cd cs
    in Curry_Prelude.nd_OP_gt_gt_eq (Curry_Directory.d_C_doesFileExist x4 cd cs)
    (wrapNX id
    (nd_OP_tryReadACYFile_dot_uscore_hash_lambda31_dot_uscore_hash_lambda32 x1
    x2 x4)) s0 cd cs)
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i
    (nd_OP_tryReadACYFile_dot_uscore_hash_lambda31 x1 x2 l s cd cs)
    (nd_OP_tryReadACYFile_dot_uscore_hash_lambda31 x1 x2 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z ->
    nd_OP_tryReadACYFile_dot_uscore_hash_lambda31 x1 x2 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c
    (nd_OP_tryReadACYFile_dot_uscore_hash_lambda31 x1 x2 e s cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "AbstractCurry.Files.tryReadACYFile._#lambda31" [show x1, show x2, show x3]
    info)
  _ -> failCons cd (consFail "AbstractCurry.Files.tryReadACYFile._#lambda31"
    (showCons x3))

d_OP_tryReadACYFile_dot_uscore_hash_lambda31_dot_uscore_hash_lambda32 :: Curry_Prelude.C_IO
  (Curry_Prelude.C_Maybe AbstractCurry.Curry_Types.C_CurryProg)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe
  AbstractCurry.Curry_Types.C_CurryProg)
d_OP_tryReadACYFile_dot_uscore_hash_lambda31_dot_uscore_hash_lambda32 x1 x2 x3 x4 cd cs =
  case x4 of
  Curry_Prelude.C_True -> d_OP_tryReadACYFile_dot_tryRead_dot_106 x1 x2 x3 cd cs
  Curry_Prelude.C_False -> x1
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i
    (d_OP_tryReadACYFile_dot_uscore_hash_lambda31_dot_uscore_hash_lambda32 x1 x2
    x3 l cd cs)
    (d_OP_tryReadACYFile_dot_uscore_hash_lambda31_dot_uscore_hash_lambda32 x1 x2
    x3 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z ->
    d_OP_tryReadACYFile_dot_uscore_hash_lambda31_dot_uscore_hash_lambda32 x1 x2
    x3 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c
    (d_OP_tryReadACYFile_dot_uscore_hash_lambda31_dot_uscore_hash_lambda32 x1 x2
    x3 e cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "AbstractCurry.Files.tryReadACYFile._#lambda31._#lambda32" [show x1, show x2
    , show x3, show x4] info)
  _ -> failCons cd (consFail
    "AbstractCurry.Files.tryReadACYFile._#lambda31._#lambda32" (showCons x4))

nd_OP_tryReadACYFile_dot_uscore_hash_lambda31_dot_uscore_hash_lambda32 :: Curry_Prelude.C_IO
  (Curry_Prelude.C_Maybe AbstractCurry.Curry_Types.C_CurryProg)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe
  AbstractCurry.Curry_Types.C_CurryProg)
nd_OP_tryReadACYFile_dot_uscore_hash_lambda31_dot_uscore_hash_lambda32 x1 x2 x3 x4 s cd cs =
  case x4 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` nd_OP_tryReadACYFile_dot_tryRead_dot_106 x1 x2 x3 s0 cd cs
  Curry_Prelude.C_False -> x1
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i
    (nd_OP_tryReadACYFile_dot_uscore_hash_lambda31_dot_uscore_hash_lambda32 x1
    x2 x3 l s cd cs)
    (nd_OP_tryReadACYFile_dot_uscore_hash_lambda31_dot_uscore_hash_lambda32 x1
    x2 x3 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z ->
    nd_OP_tryReadACYFile_dot_uscore_hash_lambda31_dot_uscore_hash_lambda32 x1 x2
    x3 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c
    (nd_OP_tryReadACYFile_dot_uscore_hash_lambda31_dot_uscore_hash_lambda32 x1
    x2 x3 e s cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "AbstractCurry.Files.tryReadACYFile._#lambda31._#lambda32" [show x1, show x2
    , show x3, show x4] info)
  _ -> failCons cd (consFail
    "AbstractCurry.Files.tryReadACYFile._#lambda31._#lambda32" (showCons x4))

d_C_writeAbstractCurryFile :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> AbstractCurry.Curry_Types.C_CurryProg -> Cover -> ConstStore
  -> Curry_Prelude.C_IO Curry_Prelude.OP_Unit
d_C_writeAbstractCurryFile x1 x2 cd cs = Curry_Prelude.d_C_writeFile x1
  (Curry_ReadShowTerm.d_C_showTerm x2 cd cs) cd cs

d_C__case_4 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_IO
  (Curry_Prelude.C_Maybe AbstractCurry.Curry_Types.C_CurryProg)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe
  AbstractCurry.Curry_Types.C_CurryProg)
d_C__case_4 x5 x6 x1 x2 x7 cd cs = case x7 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_dollar Curry_Prelude.d_C_error
    (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
    "AbstractCurry: incompatible file found: ") x2 cd cs) cd cs
  Curry_Prelude.C_False -> d_C__case_3 x6 x1
    (Curry_ReadShowTerm.d_C_readsUnqualifiedTerm (Curry_Prelude.OP_Cons
    (Curry_Prelude.toCurryString "AbstractCurry.Types") (Curry_Prelude.OP_Cons
    (Curry_Prelude.toCurryString "Prelude") Curry_Prelude.OP_List)) x6 cd cs) cd
    cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_4 x5 x6 x1 x2 l
    cd cs) (d_C__case_4 x5 x6 x1 x2 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_4 x5 x6
    x1 x2 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (d_C__case_4 x5 x6 x1 x2 e
    cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "AbstractCurry.Files._case_4" [show x5, show x6, show x1, show x2, show x7]
    info)
  _ -> failCons cd (consFail "AbstractCurry.Files._case_4" (showCons x7))

nd_C__case_4 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_IO
  (Curry_Prelude.C_Maybe AbstractCurry.Curry_Types.C_CurryProg)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Bool
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_IO
  (Curry_Prelude.C_Maybe AbstractCurry.Curry_Types.C_CurryProg)
nd_C__case_4 x5 x6 x1 x2 x7 s cd cs = case x7 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` Curry_Prelude.nd_OP_dollar (wrapDX id Curry_Prelude.d_C_error)
    (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
    "AbstractCurry: incompatible file found: ") x2 cd cs) s0 cd cs
  Curry_Prelude.C_False -> let s0 = s
    in s0 `seq` nd_C__case_3 x6 x1 (Curry_ReadShowTerm.d_C_readsUnqualifiedTerm
    (Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString "AbstractCurry.Types")
    (Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString "Prelude")
    Curry_Prelude.OP_List)) x6 cd cs) s0 cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_4 x5 x6 x1 x2 l
    s cd cs) (nd_C__case_4 x5 x6 x1 x2 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_4 x5
    x6 x1 x2 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (nd_C__case_4 x5 x6 x1 x2 e
    s cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "AbstractCurry.Files._case_4" [show x5, show x6, show x1, show x2, show x7]
    info)
  _ -> failCons cd (consFail "AbstractCurry.Files._case_4" (showCons x7))

d_C__case_3 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_IO
  (Curry_Prelude.C_Maybe AbstractCurry.Curry_Types.C_CurryProg)
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  AbstractCurry.Curry_Types.C_CurryProg (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> Cover -> ConstStore -> Curry_Prelude.C_IO
  (Curry_Prelude.C_Maybe AbstractCurry.Curry_Types.C_CurryProg)
d_C__case_3 x6 x1 x9 cd cs = case x9 of
  Curry_Prelude.OP_List -> x1
  Curry_Prelude.OP_Cons x7 x8 -> d_C__case_2 x8 x1 x7 cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_3 x6 x1 l cd cs)
    (d_C__case_3 x6 x1 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_3 x6
    x1 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c (d_C__case_3 x6 x1 e cd $!
    addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "AbstractCurry.Files._case_3" [show x6, show x1, show x9] info)
  _ -> failCons cd (consFail "AbstractCurry.Files._case_3" (showCons x9))

nd_C__case_3 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_IO
  (Curry_Prelude.C_Maybe AbstractCurry.Curry_Types.C_CurryProg)
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  AbstractCurry.Curry_Types.C_CurryProg (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe
  AbstractCurry.Curry_Types.C_CurryProg)
nd_C__case_3 x6 x1 x9 s cd cs = case x9 of
  Curry_Prelude.OP_List -> x1
  Curry_Prelude.OP_Cons x7 x8 -> let s0 = s
    in s0 `seq` nd_C__case_2 x8 x1 x7 s0 cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (nd_C__case_3 x6 x1 l s cd
    cs) (nd_C__case_3 x6 x1 r s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> nd_C__case_3 x6
    x1 z s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c (nd_C__case_3 x6 x1 e s
    cd $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "AbstractCurry.Files._case_3" [show x6, show x1, show x9] info)
  _ -> failCons cd (consFail "AbstractCurry.Files._case_3" (showCons x9))

d_C__case_2 :: Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  AbstractCurry.Curry_Types.C_CurryProg (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe
  AbstractCurry.Curry_Types.C_CurryProg) -> Curry_Prelude.OP_Tuple2
  AbstractCurry.Curry_Types.C_CurryProg (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.C_IO
  (Curry_Prelude.C_Maybe AbstractCurry.Curry_Types.C_CurryProg)
d_C__case_2 x8 x1 x7 cd cs = case x7 of
  Curry_Prelude.OP_Tuple2 x9 x10 -> d_C__case_1 x1 x10 x9 x8 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (d_C__case_2 x8 x1 l cd
    cs) (d_C__case_2 x8 x1 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> d_C__case_2 x8
    x1 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c (d_C__case_2 x8 x1 e
    cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "AbstractCurry.Files._case_2" [show x8, show x1, show x7] info)
  _ -> failCons cd (consFail "AbstractCurry.Files._case_2" (showCons x7))

nd_C__case_2 :: Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  AbstractCurry.Curry_Types.C_CurryProg (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe
  AbstractCurry.Curry_Types.C_CurryProg) -> Curry_Prelude.OP_Tuple2
  AbstractCurry.Curry_Types.C_CurryProg (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_IO
  (Curry_Prelude.C_Maybe AbstractCurry.Curry_Types.C_CurryProg)
nd_C__case_2 x8 x1 x7 s cd cs = case x7 of
  Curry_Prelude.OP_Tuple2 x9 x10 -> let s0 = s
    in s0 `seq` nd_C__case_1 x1 x10 x9 x8 s0 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (nd_C__case_2 x8 x1 l s
    cd cs) (nd_C__case_2 x8 x1 r s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> nd_C__case_2
    x8 x1 z s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c (nd_C__case_2 x8 x1 e s
    cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "AbstractCurry.Files._case_2" [show x8, show x1, show x7] info)
  _ -> failCons cd (consFail "AbstractCurry.Files._case_2" (showCons x7))

d_C__case_1 :: Curry_Prelude.C_IO (Curry_Prelude.C_Maybe
  AbstractCurry.Curry_Types.C_CurryProg) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> AbstractCurry.Curry_Types.C_CurryProg
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  AbstractCurry.Curry_Types.C_CurryProg (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> Cover -> ConstStore -> Curry_Prelude.C_IO
  (Curry_Prelude.C_Maybe AbstractCurry.Curry_Types.C_CurryProg)
d_C__case_1 x1 x10 x9 x8 cd cs = case x8 of
  Curry_Prelude.OP_List -> d_C__case_0 x10 x1 x9 (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_all Curry_Char.d_C_isSpace cd cs) x10 cd cs) cd cs
  Curry_Prelude.OP_Cons x11 x12 -> x1
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_1 x1 x10 x9 l cd
    cs) (d_C__case_1 x1 x10 x9 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_1 x1
    x10 x9 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c (d_C__case_1 x1 x10 x9 e
    cd $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "AbstractCurry.Files._case_1" [show x1, show x10, show x9, show x8] info)
  _ -> failCons cd (consFail "AbstractCurry.Files._case_1" (showCons x8))

nd_C__case_1 :: Curry_Prelude.C_IO (Curry_Prelude.C_Maybe
  AbstractCurry.Curry_Types.C_CurryProg) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> AbstractCurry.Curry_Types.C_CurryProg
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  AbstractCurry.Curry_Types.C_CurryProg (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe
  AbstractCurry.Curry_Types.C_CurryProg)
nd_C__case_1 x1 x10 x9 x8 s cd cs = case x8 of
  Curry_Prelude.OP_List -> let s4 = s
    in s4 `seq` (let s3 = leftSupply s4
                     s2 = rightSupply s4
    in s3 `seq` (s2 `seq` nd_C__case_0 x10 x1 x9 (let s1 = leftSupply s2
                                                      s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_all
    (wrapDX id Curry_Char.d_C_isSpace) s0 cd cs) x10 s1 cd cs)) s3 cd cs))
  Curry_Prelude.OP_Cons x11 x12 -> x1
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (nd_C__case_1 x1 x10 x9 l s
    cd cs) (nd_C__case_1 x1 x10 x9 r s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> nd_C__case_1 x1
    x10 x9 z s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c (nd_C__case_1 x1 x10 x9 e s
    cd $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "AbstractCurry.Files._case_1" [show x1, show x10, show x9, show x8] info)
  _ -> failCons cd (consFail "AbstractCurry.Files._case_1" (showCons x8))

d_C__case_0 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_IO
  (Curry_Prelude.C_Maybe AbstractCurry.Curry_Types.C_CurryProg)
  -> AbstractCurry.Curry_Types.C_CurryProg -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe
  AbstractCurry.Curry_Types.C_CurryProg)
d_C__case_0 x10 x1 x9 x11 cd cs = case x11 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_dollar Curry_Prelude.d_C_return
    (Curry_Prelude.C_Just x9) cd cs
  Curry_Prelude.C_False -> x1
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_0 x10 x1 x9 l cd
    cs) (d_C__case_0 x10 x1 x9 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_0 x10
    x1 x9 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (d_C__case_0 x10 x1 x9 e
    cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "AbstractCurry.Files._case_0" [show x10, show x1, show x9, show x11] info)
  _ -> failCons cd (consFail "AbstractCurry.Files._case_0" (showCons x11))

nd_C__case_0 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_IO
  (Curry_Prelude.C_Maybe AbstractCurry.Curry_Types.C_CurryProg)
  -> AbstractCurry.Curry_Types.C_CurryProg -> Curry_Prelude.C_Bool -> IDSupply
  -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe
  AbstractCurry.Curry_Types.C_CurryProg)
nd_C__case_0 x10 x1 x9 x11 s cd cs = case x11 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` Curry_Prelude.nd_OP_dollar (wrapDX id Curry_Prelude.d_C_return)
    (Curry_Prelude.C_Just x9) s0 cd cs
  Curry_Prelude.C_False -> x1
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_0 x10 x1 x9 l s
    cd cs) (nd_C__case_0 x10 x1 x9 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_0 x10
    x1 x9 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (nd_C__case_0 x10 x1 x9 e s
    cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "AbstractCurry.Files._case_0" [show x10, show x1, show x9, show x11] info)
  _ -> failCons cd (consFail "AbstractCurry.Files._case_0" (showCons x11))

d_C__case_5 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.C_IO t0
d_C__case_5 x4 x1 x5 x6 cd cs = case x6 of
  Curry_Prelude.C_True -> Curry_Prelude.d_C_return
    (Curry_ReadShowTerm.d_C_readUnqualifiedTerm (Curry_Prelude.OP_Cons
    (Curry_Prelude.toCurryString "AbstractCurry.Types") (Curry_Prelude.OP_Cons
    (Curry_Prelude.toCurryString "Prelude") Curry_Prelude.OP_List)) x5 cd cs) cd
    cs
  Curry_Prelude.C_False -> Curry_Prelude.d_OP_dollar Curry_Prelude.d_C_error
    (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
    "AbstractCurry: incompatible file found: ") x1 cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_5 x4 x1 x5 l cd
    cs) (d_C__case_5 x4 x1 x5 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_5 x4 x1
    x5 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (d_C__case_5 x4 x1 x5 e
    cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "AbstractCurry.Files._case_5" [show x4, show x1, show x5, show x6] info)
  _ -> failCons cd (consFail "AbstractCurry.Files._case_5" (showCons x6))

d_C__case_6 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Distribution.C_FrontendParams -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.C_IO
  AbstractCurry.Curry_Types.C_CurryProg
d_C__case_6 x1 x3 x2 x5 cd cs = case x5 of
  Curry_Prelude.OP_Tuple2 x6 x7 -> Curry_Prelude.d_OP_gt_gt
    (Curry_Distribution.d_C_callFrontendWithParams Curry_Distribution.C_UACY x2
    x3 cd cs) (d_C_readAbstractCurryFile (d_C_untypedAbstractCurryFileName
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_FilePath.d_OP_lt_slash_gt cd cs) x6 cd cs) x1 cd cs) cd cs) cd cs) cd
    cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (d_C__case_6 x1 x3 x2 l
    cd cs) (d_C__case_6 x1 x3 x2 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> d_C__case_6 x1
    x3 x2 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c (d_C__case_6 x1 x3 x2 e
    cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "AbstractCurry.Files._case_6" [show x1, show x3, show x2, show x5] info)
  _ -> failCons cd (consFail "AbstractCurry.Files._case_6" (showCons x5))

d_C__case_7 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Distribution.C_FrontendParams -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.C_IO
  AbstractCurry.Curry_Types.C_CurryProg
d_C__case_7 x1 x3 x2 x5 cd cs = case x5 of
  Curry_Prelude.OP_Tuple2 x6 x7 -> Curry_Prelude.d_OP_gt_gt
    (Curry_Distribution.d_C_callFrontendWithParams Curry_Distribution.C_ACY x2
    x3 cd cs) (d_C_readAbstractCurryFile (d_C_abstractCurryFileName
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_FilePath.d_OP_lt_slash_gt cd cs) x6 cd cs) x1 cd cs) cd cs) cd cs) cd
    cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (d_C__case_7 x1 x3 x2 l
    cd cs) (d_C__case_7 x1 x3 x2 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> d_C__case_7 x1
    x3 x2 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c (d_C__case_7 x1 x3 x2 e
    cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "AbstractCurry.Files._case_7" [show x1, show x3, show x2, show x5] info)
  _ -> failCons cd (consFail "AbstractCurry.Files._case_7" (showCons x5))

d_C__case_12 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.C_IO (Curry_Prelude.C_Either (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) AbstractCurry.Curry_Types.C_CurryProg)
d_C__case_12 x4 x5 x1 x7 cd cs = case x7 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_dollar
    d_OP_tryParse_dot_cancel_dot_52 (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "Could not parse AbstractCurry file '")
    (Curry_Prelude.d_OP_plus_plus x1 (Curry_Prelude.toCurryString
    "': incompatible versions") cd cs) cd cs) cd cs
  Curry_Prelude.C_False -> let x6 = Curry_ReadShowTerm.d_C_readsUnqualifiedTerm
                                 (Curry_Prelude.OP_Cons
                                 (Curry_Prelude.toCurryString
                                 "AbstractCurry.Types") (Curry_Prelude.OP_Cons
                                 (Curry_Prelude.toCurryString "Prelude")
                                 Curry_Prelude.OP_List)) x5 cd cs
    in d_C__case_11 x1 x6 cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_12 x4 x5 x1 l cd
    cs) (d_C__case_12 x4 x5 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_12 x4
    x5 x1 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (d_C__case_12 x4 x5 x1 e
    cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "AbstractCurry.Files._case_12" [show x4, show x5, show x1, show x7] info)
  _ -> failCons cd (consFail "AbstractCurry.Files._case_12" (showCons x7))

d_C__case_11 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  AbstractCurry.Curry_Types.C_CurryProg (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> Cover -> ConstStore -> Curry_Prelude.C_IO
  (Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  AbstractCurry.Curry_Types.C_CurryProg)
d_C__case_11 x1 x6 cd cs = case x6 of
  Curry_Prelude.OP_Cons x7 x8 -> d_C__case_10 x8 x1 x7 cd cs
  Curry_Prelude.OP_List -> Curry_Prelude.d_OP_dollar
    d_OP_tryParse_dot_cancel_dot_52 (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "Could not parse AbstractCurry file '")
    (Curry_Prelude.d_OP_plus_plus x1 (Curry_Prelude.toCurryString "': no parse")
    cd cs) cd cs) cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_11 x1 l cd cs)
    (d_C__case_11 x1 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_11 x1
    z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c (d_C__case_11 x1 e cd $!
    addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "AbstractCurry.Files._case_11" [show x1, show x6] info)
  _ -> failCons cd (consFail "AbstractCurry.Files._case_11" (showCons x6))

d_C__case_10 :: Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  AbstractCurry.Curry_Types.C_CurryProg (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_Tuple2 AbstractCurry.Curry_Types.C_CurryProg
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore
  -> Curry_Prelude.C_IO (Curry_Prelude.C_Either (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) AbstractCurry.Curry_Types.C_CurryProg)
d_C__case_10 x8 x1 x7 cd cs = case x7 of
  Curry_Prelude.OP_Tuple2 x9 x10 -> d_C__case_9 x1 x10 x9 x8 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (d_C__case_10 x8 x1 l cd
    cs) (d_C__case_10 x8 x1 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> d_C__case_10
    x8 x1 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c (d_C__case_10 x8 x1 e
    cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "AbstractCurry.Files._case_10" [show x8, show x1, show x7] info)
  _ -> failCons cd (consFail "AbstractCurry.Files._case_10" (showCons x7))

d_C__case_9 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> AbstractCurry.Curry_Types.C_CurryProg -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 AbstractCurry.Curry_Types.C_CurryProg
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Cover -> ConstStore
  -> Curry_Prelude.C_IO (Curry_Prelude.C_Either (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) AbstractCurry.Curry_Types.C_CurryProg)
d_C__case_9 x1 x10 x9 x8 cd cs = case x8 of
  Curry_Prelude.OP_List -> d_C__case_8 x10 x1 x9 (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_all Curry_Char.d_C_isSpace cd cs) x10 cd cs) cd cs
  Curry_Prelude.OP_Cons x11 x12 -> Curry_Prelude.d_OP_dollar
    d_OP_tryParse_dot_cancel_dot_52 (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "Could not parse AbstractCurry file '")
    (Curry_Prelude.d_OP_plus_plus x1 (Curry_Prelude.toCurryString "': no parse")
    cd cs) cd cs) cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_9 x1 x10 x9 l cd
    cs) (d_C__case_9 x1 x10 x9 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_9 x1
    x10 x9 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c (d_C__case_9 x1 x10 x9 e
    cd $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "AbstractCurry.Files._case_9" [show x1, show x10, show x9, show x8] info)
  _ -> failCons cd (consFail "AbstractCurry.Files._case_9" (showCons x8))

d_C__case_8 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> AbstractCurry.Curry_Types.C_CurryProg -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Either
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  AbstractCurry.Curry_Types.C_CurryProg)
d_C__case_8 x10 x1 x9 x11 cd cs = case x11 of
  Curry_Prelude.C_True -> Curry_Prelude.d_C_return (Curry_Prelude.C_Right x9) cd
    cs
  Curry_Prelude.C_False -> Curry_Prelude.d_OP_dollar
    d_OP_tryParse_dot_cancel_dot_52 (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "Could not parse AbstractCurry file '")
    (Curry_Prelude.d_OP_plus_plus x1 (Curry_Prelude.toCurryString "': no parse")
    cd cs) cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_8 x10 x1 x9 l cd
    cs) (d_C__case_8 x10 x1 x9 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_8 x10
    x1 x9 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (d_C__case_8 x10 x1 x9 e
    cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "AbstractCurry.Files._case_8" [show x10, show x1, show x9, show x11] info)
  _ -> failCons cd (consFail "AbstractCurry.Files._case_8" (showCons x11))

d_C__case_13 :: Curry_Prelude.C_Bool -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.C_IO (Curry_Prelude.C_Either (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) AbstractCurry.Curry_Types.C_CurryProg)
d_C__case_13 x2 x1 x3 cd cs = case x3 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_dollar
    d_OP_tryParse_dot_cancel_dot_52 (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "AbstractCurry file '")
    (Curry_Prelude.d_OP_plus_plus x1 (Curry_Prelude.toCurryString
    "' does not exist") cd cs) cd cs) cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_OP_gt_gt_eq
    (Curry_Prelude.d_C_readFile x1 cd cs)
    (d_OP_tryParse_dot_uscore_hash_lambda14_dot_uscore_hash_lambda15 x1) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_13 x2 x1 l cd cs)
    (d_C__case_13 x2 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_13 x2
    x1 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (d_C__case_13 x2 x1 e cd $!
    addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "AbstractCurry.Files._case_13" [show x2, show x1, show x3] info)
  _ -> failCons cd (consFail "AbstractCurry.Files._case_13" (showCons x3))

d_C__case_14 :: Curry_Time.C_ClockTime -> Curry_Time.C_ClockTime
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.C_IO (Curry_Prelude.C_Either (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) AbstractCurry.Curry_Types.C_CurryProg)
d_C__case_14 x4 x1 x2 x3 x5 cd cs = case x5 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_dollar
    d_OP_tryReadCurryFile_dot_cancel_dot_30 (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "Source file '") (Curry_Prelude.d_OP_plus_plus
    x3 (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
    "' is newer than AbstractCurry file '") (Curry_Prelude.d_OP_plus_plus x2
    (Curry_Prelude.toCurryString "'") cd cs) cd cs) cd cs) cd cs) cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_OP_gt_gt_eq (d_C_tryParse x2 cd cs)
    d_OP_tryReadCurryFile_dot_uscore_hash_lambda6_dot_uscore_hash_lambda8_dot_uscore_hash_lambda10_dot_uscore_hash_lambda11_dot_uscore_hash_lambda12
    cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_14 x4 x1 x2 x3 l
    cd cs) (d_C__case_14 x4 x1 x2 x3 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_14 x4
    x1 x2 x3 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (d_C__case_14 x4 x1 x2 x3 e
    cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "AbstractCurry.Files._case_14" [show x4, show x1, show x2, show x3, show x5]
    info)
  _ -> failCons cd (consFail "AbstractCurry.Files._case_14" (showCons x5))

d_C__case_15 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore
  -> Curry_Prelude.C_IO (Curry_Prelude.C_Either (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) AbstractCurry.Curry_Types.C_CurryProg)
d_C__case_15 x1 x3 cd cs = case x3 of
  Curry_Prelude.OP_Tuple2 x4 x5 -> Curry_Prelude.d_OP_gt_gt
    (Curry_Distribution.d_C_callFrontendWithParams Curry_Distribution.C_ACY
    (Curry_Distribution.d_C_setQuiet Curry_Prelude.C_True
    (Curry_Distribution.d_C_defaultParams cd cs) cd cs) x1 cd cs)
    (Curry_Prelude.d_OP_gt_gt_eq (Curry_Prelude.d_OP_gt_gt_eq
    (Curry_Distribution.d_C_getLoadPathForModule x1 cd cs)
    (Curry_FileGoodies.d_C_lookupFileInPath (d_C_abstractCurryFileName x1 cd cs)
    (Curry_Prelude.OP_Cons Curry_Prelude.OP_List Curry_Prelude.OP_List)) cd cs)
    (d_OP_tryReadCurryFile_dot_uscore_hash_lambda6_dot_uscore_hash_lambda8 x1
    x5) cd cs) cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (d_C__case_15 x1 l cd cs)
    (d_C__case_15 x1 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> d_C__case_15
    x1 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c (d_C__case_15 x1 e cd $!
    addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "AbstractCurry.Files._case_15" [show x1, show x3] info)
  _ -> failCons cd (consFail "AbstractCurry.Files._case_15" (showCons x3))

d_C__case_16 :: Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> AbstractCurry.Curry_Types.C_CurryProg -> Cover -> ConstStore
  -> Curry_Prelude.C_IO (Curry_Prelude.C_Either (Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CurryProg))
d_C__case_16 x3 x1 x2 x6 cd cs = case x6 of
  AbstractCurry.Curry_Types.C_CurryProg x7 x8 x9 x10 x11 -> Curry_Prelude.d_OP_gt_gt_eq
    (d_OP_tryReadCurryWithImports_dot_collect_dot_13 (Curry_Prelude.OP_Cons x2
    x1) (Curry_Prelude.d_OP_plus_plus x3 x8 cd cs) cd cs)
    (d_OP_tryReadCurryWithImports_dot_collect_dot_13_dot_uscore_hash_lambda3_dot_uscore_hash_lambda5
    x6) cd cs
  AbstractCurry.Curry_Types.Choice_C_CurryProg d i l r -> narrow d i
    (d_C__case_16 x3 x1 x2 l cd cs) (d_C__case_16 x3 x1 x2 r cd cs)
  AbstractCurry.Curry_Types.Choices_C_CurryProg d i xs -> narrows cs d i (\z ->
    d_C__case_16 x3 x1 x2 z cd cs) xs
  AbstractCurry.Curry_Types.Guard_C_CurryProg d c e -> guardCons d c
    (d_C__case_16 x3 x1 x2 e cd $! addCs c cs)
  AbstractCurry.Curry_Types.Fail_C_CurryProg d info -> failCons d (traceFail
    "AbstractCurry.Files._case_16" [show x3, show x1, show x2, show x6] info)
  _ -> failCons cd (consFail "AbstractCurry.Files._case_16" (showCons x6))

d_C__case_18 :: Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.C_IO
  (Curry_Prelude.C_Either (Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CurryProg))
d_C__case_18 x1 x3 x4 x5 cd cs = case x5 of
  Curry_Prelude.C_True -> d_OP_tryReadCurryWithImports_dot_collect_dot_13 x1 x4
    cd cs
  Curry_Prelude.C_False -> d_C__case_17 x4 x3 x1 (Curry_Prelude.d_C_otherwise cd
    cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_18 x1 x3 x4 l cd
    cs) (d_C__case_18 x1 x3 x4 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_18 x1
    x3 x4 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (d_C__case_18 x1 x3 x4 e
    cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "AbstractCurry.Files._case_18" [show x1, show x3, show x4, show x5] info)
  _ -> failCons cd (consFail "AbstractCurry.Files._case_18" (showCons x5))

d_C__case_17 :: Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.C_IO
  (Curry_Prelude.C_Either (Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CurryProg))
d_C__case_17 x4 x3 x1 x5 cd cs = case x5 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_gt_gt_eq (d_C_tryReadCurryFile x3
    cd cs)
    (d_OP_tryReadCurryWithImports_dot_collect_dot_13_dot_uscore_hash_lambda3 x1
    x3 x4) cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_17 x4 x3 x1 l cd
    cs) (d_C__case_17 x4 x3 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_17 x4
    x3 x1 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (d_C__case_17 x4 x3 x1 e
    cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "AbstractCurry.Files._case_17" [show x4, show x3, show x1, show x5] info)
  _ -> failCons cd (consFail "AbstractCurry.Files._case_17" (showCons x5))

d_C__case_20 :: Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.C_IO
  (Curry_Prelude.OP_List AbstractCurry.Curry_Types.C_CurryProg)
d_C__case_20 x1 x3 x4 x5 cd cs = case x5 of
  Curry_Prelude.C_True -> d_OP_readCurryWithImports_dot_collect_dot_4 x1 x4 cd
    cs
  Curry_Prelude.C_False -> d_C__case_19 x4 x3 x1 (Curry_Prelude.d_C_otherwise cd
    cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_20 x1 x3 x4 l cd
    cs) (d_C__case_20 x1 x3 x4 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_20 x1
    x3 x4 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (d_C__case_20 x1 x3 x4 e
    cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "AbstractCurry.Files._case_20" [show x1, show x3, show x4, show x5] info)
  _ -> failCons cd (consFail "AbstractCurry.Files._case_20" (showCons x5))

d_C__case_19 :: Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.C_IO
  (Curry_Prelude.OP_List AbstractCurry.Curry_Types.C_CurryProg)
d_C__case_19 x4 x3 x1 x5 cd cs = case x5 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_gt_gt_eq (d_C_readCurry x3 cd cs)
    (d_OP_readCurryWithImports_dot_collect_dot_4_dot_uscore_hash_lambda1 x1 x3
    x4) cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_19 x4 x3 x1 l cd
    cs) (d_C__case_19 x4 x3 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_19 x4
    x3 x1 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (d_C__case_19 x4 x3 x1 e
    cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "AbstractCurry.Files._case_19" [show x4, show x3, show x1, show x5] info)
  _ -> failCons cd (consFail "AbstractCurry.Files._case_19" (showCons x5))

