{-# LANGUAGE MagicHash #-}
{-# LANGUAGE ScopedTypeVariables #-}
{-# OPTIONS_GHC -fno-warn-overlapping-patterns #-}

module Curry_State
  ( C_State
  , d_C_bindS
  , nd_C_bindS
  , d_C_bindS_
  , nd_C_bindS_
  , d_C_returnS
  , d_C_getS
  , d_C_putS
  , d_C_modifyS
  , nd_C_modifyS
  , d_C_sequenceS
  , nd_C_sequenceS
  , d_C_sequenceS_
  , nd_C_sequenceS_
  , d_C_mapS
  , nd_C_mapS
  , d_C_mapS_
  , nd_C_mapS_
  , d_C_runState
  , nd_C_runState
  , d_C_evalState
  , nd_C_evalState
  , d_C_execState
  , nd_C_execState
  , d_C_liftS
  , nd_C_liftS
  , d_C_liftS2
  , nd_C_liftS2 )
  where

import Basics
import qualified Curry_Prelude


type C_State t0 t1 = t0 -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 t1 t0

d_C_bindS :: forall t1 t2 t0 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry t2
  , Curry_Prelude.Curry t0) => (t0 -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 t1 t0) -> (t1 -> Cover -> ConstStore -> t0 -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 t2 t0) -> t0 -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 t2 t0
d_C_bindS x1 x2 x3 cd cs = d_C__case_0 x3 x1 x2 (Curry_Prelude.d_C_apply x1 x3
  cd cs) cd cs

nd_C_bindS :: forall t1 t2 t0 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry t2
  , Curry_Prelude.Curry t0) => Func t0 (Curry_Prelude.OP_Tuple2 t1 t0) -> Func
  t1 (Func t0 (Curry_Prelude.OP_Tuple2 t2 t0)) -> t0 -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 t2 t0
nd_C_bindS x1 x2 x3 s cd cs = let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` nd_C__case_0 x3 x1 x2 (Curry_Prelude.nd_C_apply x1 x3 s0
  cd cs) s1 cd cs))

d_C_bindS_ :: forall t1 t2 t0 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry t2
  , Curry_Prelude.Curry t0) => (t0 -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 t1 t0) -> (t0 -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 t2 t0) -> Cover -> ConstStore -> t0 -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 t2 t0
d_C_bindS_ x1 x2 cd cs = d_C_bindS x1 (d_OP_bindS_uscore_dot_uscore_hash_lambda2
  x2)

nd_C_bindS_ :: forall t1 t2 t0 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry t2
  , Curry_Prelude.Curry t0) => Func t0 (Curry_Prelude.OP_Tuple2 t1 t0) -> Func
  t0 (Curry_Prelude.OP_Tuple2 t2 t0) -> IDSupply -> Cover -> ConstStore -> Func
  t0 (Curry_Prelude.OP_Tuple2 t2 t0)
nd_C_bindS_ x1 x2 s cd cs = wrapNX id (nd_C_bindS x1 (wrapNX id
  (nd_OP_bindS_uscore_dot_uscore_hash_lambda2 x2)))

d_OP_bindS_uscore_dot_uscore_hash_lambda2 :: forall t2 t1
  t0 . (Curry_Prelude.Curry t2, Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => (t0 -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 t1 t0) -> t2
  -> Cover -> ConstStore -> t0 -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  t1 t0
d_OP_bindS_uscore_dot_uscore_hash_lambda2 x1 x2 cd cs = x1

nd_OP_bindS_uscore_dot_uscore_hash_lambda2 :: forall t2 t1
  t0 . (Curry_Prelude.Curry t2, Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Func t0 (Curry_Prelude.OP_Tuple2 t1 t0) -> t2 -> IDSupply -> Cover
  -> ConstStore -> Func t0 (Curry_Prelude.OP_Tuple2 t1 t0)
nd_OP_bindS_uscore_dot_uscore_hash_lambda2 x1 x2 s cd cs = x1

d_C_returnS :: forall t0 t1 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry
  t1) => t0 -> t1 -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 t0 t1
d_C_returnS x1 x2 cd cs = Curry_Prelude.OP_Tuple2 x1 x2

d_C_getS :: forall t0 . (Curry_Prelude.Curry t0) => t0 -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 t0 t0
d_C_getS x1 cd cs = Curry_Prelude.OP_Tuple2 x1 x1

d_C_putS :: forall t0 . (Curry_Prelude.Curry t0) => t0 -> t0 -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 Curry_Prelude.OP_Unit t0
d_C_putS x1 x2 cd cs = Curry_Prelude.OP_Tuple2 Curry_Prelude.OP_Unit x1

d_C_modifyS :: forall t0 . (Curry_Prelude.Curry t0) => (t0 -> Cover
  -> ConstStore -> t0) -> t0 -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  Curry_Prelude.OP_Unit t0
d_C_modifyS x1 x2 cd cs = Curry_Prelude.OP_Tuple2 Curry_Prelude.OP_Unit
  (Curry_Prelude.d_C_apply x1 x2 cd cs)

nd_C_modifyS :: forall t0 . (Curry_Prelude.Curry t0) => Func t0 t0 -> t0
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  Curry_Prelude.OP_Unit t0
nd_C_modifyS x1 x2 s cd cs = let s0 = s
  in s0 `seq` Curry_Prelude.OP_Tuple2 Curry_Prelude.OP_Unit
  (Curry_Prelude.nd_C_apply x1 x2 s0 cd cs)

d_C_sequenceS :: forall t1 t0 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Cover -> ConstStore -> Curry_Prelude.OP_List (t0 -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 t1 t0) -> Cover -> ConstStore -> t0 -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t1) t0
d_C_sequenceS cd cs = Curry_Prelude.d_C_foldr (acceptCs id
  d_OP_sequenceS_dot_uscore_hash_lambda3) (d_C_returnS Curry_Prelude.OP_List)

nd_C_sequenceS :: forall t1 t0 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => IDSupply -> Cover -> ConstStore -> Func (Curry_Prelude.OP_List (Func t0
  (Curry_Prelude.OP_Tuple2 t1 t0))) (Func t0 (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List t1) t0))
nd_C_sequenceS s cd cs = wrapNX id (Curry_Prelude.nd_C_foldr (wrapDX (wrapNX id)
  (acceptCs id nd_OP_sequenceS_dot_uscore_hash_lambda3)) (wrapDX id (d_C_returnS
  Curry_Prelude.OP_List)))

d_OP_sequenceS_dot_uscore_hash_lambda3 :: forall t1 t0 . (Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t0) => (t0 -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 t1 t0) -> (t0 -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t1) t0) -> Cover
  -> ConstStore -> t0 -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List t1) t0
d_OP_sequenceS_dot_uscore_hash_lambda3 x1 x2 cd cs = d_C_bindS x1
  (d_OP_sequenceS_dot_uscore_hash_lambda3_dot_uscore_hash_lambda4 x2)

nd_OP_sequenceS_dot_uscore_hash_lambda3 :: forall t1 t0 . (Curry_Prelude.Curry
  t1, Curry_Prelude.Curry t0) => Func t0 (Curry_Prelude.OP_Tuple2 t1 t0) -> Func
  t0 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t1) t0) -> IDSupply
  -> Cover -> ConstStore -> Func t0 (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List t1) t0)
nd_OP_sequenceS_dot_uscore_hash_lambda3 x1 x2 s cd cs = wrapNX id (nd_C_bindS x1
  (wrapNX id (nd_OP_sequenceS_dot_uscore_hash_lambda3_dot_uscore_hash_lambda4
  x2)))

d_OP_sequenceS_dot_uscore_hash_lambda3_dot_uscore_hash_lambda4 :: forall t1
  t0 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry t0) => (t0 -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t1) t0) -> t1
  -> Cover -> ConstStore -> t0 -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List t1) t0
d_OP_sequenceS_dot_uscore_hash_lambda3_dot_uscore_hash_lambda4 x1 x2 cd cs =
  d_C_bindS x1
  (d_OP_sequenceS_dot_uscore_hash_lambda3_dot_uscore_hash_lambda4_dot_uscore_hash_lambda5
  x2)

nd_OP_sequenceS_dot_uscore_hash_lambda3_dot_uscore_hash_lambda4 :: forall t1
  t0 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry t0) => Func t0
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t1) t0) -> t1 -> IDSupply
  -> Cover -> ConstStore -> Func t0 (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List t1) t0)
nd_OP_sequenceS_dot_uscore_hash_lambda3_dot_uscore_hash_lambda4 x1 x2 s cd cs =
  wrapNX id (nd_C_bindS x1 (wrapDX (wrapDX id)
  (d_OP_sequenceS_dot_uscore_hash_lambda3_dot_uscore_hash_lambda4_dot_uscore_hash_lambda5
  x2)))

d_OP_sequenceS_dot_uscore_hash_lambda3_dot_uscore_hash_lambda4_dot_uscore_hash_lambda5 :: forall t0
  t1 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry t1) => t0
  -> Curry_Prelude.OP_List t0 -> Cover -> ConstStore -> t1 -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t0) t1
d_OP_sequenceS_dot_uscore_hash_lambda3_dot_uscore_hash_lambda4_dot_uscore_hash_lambda5 x1 x2 cd cs =
  d_C_returnS (Curry_Prelude.OP_Cons x1 x2)

d_C_sequenceS_ :: forall t1 t0 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Cover -> ConstStore -> Curry_Prelude.OP_List (t0 -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 t1 t0) -> Cover -> ConstStore -> t0 -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 Curry_Prelude.OP_Unit t0
d_C_sequenceS_ cd cs = Curry_Prelude.d_C_foldr (acceptCs id d_C_bindS_)
  (d_C_returnS Curry_Prelude.OP_Unit)

nd_C_sequenceS_ :: forall t1 t0 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => IDSupply -> Cover -> ConstStore -> Func (Curry_Prelude.OP_List (Func t0
  (Curry_Prelude.OP_Tuple2 t1 t0))) (Func t0 (Curry_Prelude.OP_Tuple2
  Curry_Prelude.OP_Unit t0))
nd_C_sequenceS_ s cd cs = wrapNX id (Curry_Prelude.nd_C_foldr (wrapDX (wrapNX
  id) (acceptCs id nd_C_bindS_)) (wrapDX id (d_C_returnS
  Curry_Prelude.OP_Unit)))

d_C_mapS :: forall t0 t2 t1 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry t2
  , Curry_Prelude.Curry t1) => (t0 -> Cover -> ConstStore -> t1 -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 t2 t1) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List t0 -> Cover -> ConstStore -> t1 -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t2) t1
d_C_mapS x1 cd cs = Curry_Prelude.d_OP_dot (d_C_sequenceS cd cs)
  (Curry_Prelude.d_C_map x1) cd cs

nd_C_mapS :: forall t0 t2 t1 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry t2
  , Curry_Prelude.Curry t1) => Func t0 (Func t1 (Curry_Prelude.OP_Tuple2 t2 t1))
  -> IDSupply -> Cover -> ConstStore -> Func (Curry_Prelude.OP_List t0) (Func t1
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t2) t1))
nd_C_mapS x1 s cd cs = let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_OP_dot (nd_C_sequenceS s0 cd cs)
  (wrapNX id (Curry_Prelude.nd_C_map x1)) s1 cd cs))

d_C_mapS_ :: forall t2 t0 t1 . (Curry_Prelude.Curry t2, Curry_Prelude.Curry t0
  , Curry_Prelude.Curry t1) => (t0 -> Cover -> ConstStore -> t1 -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 t2 t1) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List t0 -> Cover -> ConstStore -> t1 -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 Curry_Prelude.OP_Unit t1
d_C_mapS_ x1 cd cs = Curry_Prelude.d_OP_dot (d_C_sequenceS_ cd cs)
  (Curry_Prelude.d_C_map x1) cd cs

nd_C_mapS_ :: forall t2 t0 t1 . (Curry_Prelude.Curry t2, Curry_Prelude.Curry t0
  , Curry_Prelude.Curry t1) => Func t0 (Func t1 (Curry_Prelude.OP_Tuple2 t2 t1))
  -> IDSupply -> Cover -> ConstStore -> Func (Curry_Prelude.OP_List t0) (Func t1
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.OP_Unit t1))
nd_C_mapS_ x1 s cd cs = let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_OP_dot (nd_C_sequenceS_ s0 cd cs)
  (wrapNX id (Curry_Prelude.nd_C_map x1)) s1 cd cs))

d_C_runState :: forall t1 t0 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => (t0 -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 t1 t0) -> t0
  -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 t1 t0
d_C_runState x1 x2 cd cs = Curry_Prelude.d_C_apply x1 x2 cd cs

nd_C_runState :: forall t1 t0 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Func t0 (Curry_Prelude.OP_Tuple2 t1 t0) -> t0 -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 t1 t0
nd_C_runState x1 x2 s cd cs = let s0 = s
  in s0 `seq` Curry_Prelude.nd_C_apply x1 x2 s0 cd cs

d_C_evalState :: forall t0 t1 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry
  t1) => (t0 -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 t1 t0) -> t0
  -> Cover -> ConstStore -> t1
d_C_evalState x1 x2 cd cs = Curry_Prelude.d_C_fst (d_C_runState x1 x2 cd cs) cd
  cs

nd_C_evalState :: forall t0 t1 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry
  t1) => Func t0 (Curry_Prelude.OP_Tuple2 t1 t0) -> t0 -> IDSupply -> Cover
  -> ConstStore -> t1
nd_C_evalState x1 x2 s cd cs = let s0 = s
  in s0 `seq` Curry_Prelude.d_C_fst (nd_C_runState x1 x2 s0 cd cs) cd cs

d_C_execState :: forall t1 t0 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => (t0 -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 t1 t0) -> t0
  -> Cover -> ConstStore -> t0
d_C_execState x1 x2 cd cs = Curry_Prelude.d_C_snd (d_C_runState x1 x2 cd cs) cd
  cs

nd_C_execState :: forall t1 t0 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Func t0 (Curry_Prelude.OP_Tuple2 t1 t0) -> t0 -> IDSupply -> Cover
  -> ConstStore -> t0
nd_C_execState x1 x2 s cd cs = let s0 = s
  in s0 `seq` Curry_Prelude.d_C_snd (nd_C_runState x1 x2 s0 cd cs) cd cs

d_C_liftS :: forall t0 t1 t2 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t2) => (t0 -> Cover -> ConstStore -> t1) -> (t2 -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 t0 t2) -> Cover -> ConstStore -> t2
  -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 t1 t2
d_C_liftS x1 x2 cd cs = d_C_bindS x2 (Curry_Prelude.d_OP_dot (acceptCs id
  d_C_returnS) x1 cd cs)

nd_C_liftS :: forall t0 t1 t2 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t2) => Func t0 t1 -> Func t2 (Curry_Prelude.OP_Tuple2 t0
  t2) -> IDSupply -> Cover -> ConstStore -> Func t2 (Curry_Prelude.OP_Tuple2 t1
  t2)
nd_C_liftS x1 x2 s cd cs = let s0 = s
  in s0 `seq` wrapNX id (nd_C_bindS x2 (Curry_Prelude.nd_OP_dot (wrapDX (wrapDX
  id) (acceptCs id d_C_returnS)) x1 s0 cd cs))

d_C_liftS2 :: forall t0 t1 t2 t3 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry
  t1, Curry_Prelude.Curry t2, Curry_Prelude.Curry t3) => (t0 -> Cover
  -> ConstStore -> t1 -> Cover -> ConstStore -> t2) -> (t3 -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 t0 t3) -> (t3 -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 t1 t3) -> Cover -> ConstStore -> t3 -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 t2 t3
d_C_liftS2 x1 x2 x3 cd cs = d_C_bindS x2 (d_OP_liftS2_dot_uscore_hash_lambda6 x3
  x1)

nd_C_liftS2 :: forall t0 t1 t2 t3 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry
  t1, Curry_Prelude.Curry t2, Curry_Prelude.Curry t3) => Func t0 (Func t1 t2)
  -> Func t3 (Curry_Prelude.OP_Tuple2 t0 t3) -> Func t3 (Curry_Prelude.OP_Tuple2
  t1 t3) -> IDSupply -> Cover -> ConstStore -> Func t3 (Curry_Prelude.OP_Tuple2
  t2 t3)
nd_C_liftS2 x1 x2 x3 s cd cs = wrapNX id (nd_C_bindS x2 (wrapNX id
  (nd_OP_liftS2_dot_uscore_hash_lambda6 x3 x1)))

d_OP_liftS2_dot_uscore_hash_lambda6 :: forall t1 t2 t3 t0 . (Curry_Prelude.Curry
  t1, Curry_Prelude.Curry t2, Curry_Prelude.Curry t3, Curry_Prelude.Curry
  t0) => (t0 -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 t1 t0) -> (t2
  -> Cover -> ConstStore -> t1 -> Cover -> ConstStore -> t3) -> t2 -> Cover
  -> ConstStore -> t0 -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 t3 t0
d_OP_liftS2_dot_uscore_hash_lambda6 x1 x2 x3 cd cs = d_C_bindS x1
  (d_OP_liftS2_dot_uscore_hash_lambda6_dot_uscore_hash_lambda7 x2 x3)

nd_OP_liftS2_dot_uscore_hash_lambda6 :: forall t1 t2 t3
  t0 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry t2, Curry_Prelude.Curry t3
  , Curry_Prelude.Curry t0) => Func t0 (Curry_Prelude.OP_Tuple2 t1 t0) -> Func
  t2 (Func t1 t3) -> t2 -> IDSupply -> Cover -> ConstStore -> Func t0
  (Curry_Prelude.OP_Tuple2 t3 t0)
nd_OP_liftS2_dot_uscore_hash_lambda6 x1 x2 x3 s cd cs = wrapNX id (nd_C_bindS x1
  (wrapNX id (nd_OP_liftS2_dot_uscore_hash_lambda6_dot_uscore_hash_lambda7 x2
  x3)))

d_OP_liftS2_dot_uscore_hash_lambda6_dot_uscore_hash_lambda7 :: forall t0 t1 t2
  t3 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry t1, Curry_Prelude.Curry t2
  , Curry_Prelude.Curry t3) => (t0 -> Cover -> ConstStore -> t1 -> Cover
  -> ConstStore -> t2) -> t0 -> t1 -> Cover -> ConstStore -> t3 -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 t2 t3
d_OP_liftS2_dot_uscore_hash_lambda6_dot_uscore_hash_lambda7 x1 x2 x3 cd cs =
  d_C_returnS (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply x1 x2 cd cs) x3
  cd cs)

nd_OP_liftS2_dot_uscore_hash_lambda6_dot_uscore_hash_lambda7 :: forall t0 t1 t2
  t3 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry t1, Curry_Prelude.Curry t2
  , Curry_Prelude.Curry t3) => Func t0 (Func t1 t2) -> t0 -> t1 -> IDSupply
  -> Cover -> ConstStore -> Func t3 (Curry_Prelude.OP_Tuple2 t2 t3)
nd_OP_liftS2_dot_uscore_hash_lambda6_dot_uscore_hash_lambda7 x1 x2 x3 s cd cs =
  let s2 = s
  in s2 `seq` wrapDX id (d_C_returnS (let s1 = leftSupply s2
                                          s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_apply x1 x2
  s0 cd cs) x3 s1 cd cs)))

d_C__case_0 :: forall t1 t2 t0 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry t2
  , Curry_Prelude.Curry t0) => t0 -> (t0 -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 t1 t0) -> (t1 -> Cover -> ConstStore -> t0 -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 t2 t0) -> Curry_Prelude.OP_Tuple2 t1
  t0 -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 t2 t0
d_C__case_0 x3 x1 x2 x6 cd cs = case x6 of
  Curry_Prelude.OP_Tuple2 x4 x5 -> Curry_Prelude.d_C_seq x5
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply x2 x4 cd cs) x5 cd cs) cd
    cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (d_C__case_0 x3 x1 x2 l
    cd cs) (d_C__case_0 x3 x1 x2 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> d_C__case_0 x3
    x1 x2 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c (d_C__case_0 x3 x1 x2 e
    cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail "State._case_0"
    [show x3, show x1, show x2, show x6] info)
  _ -> failCons cd (consFail "State._case_0" (showCons x6))

nd_C__case_0 :: forall t1 t2 t0 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t2, Curry_Prelude.Curry t0) => t0 -> Func t0 (Curry_Prelude.OP_Tuple2 t1 t0)
  -> Func t1 (Func t0 (Curry_Prelude.OP_Tuple2 t2 t0))
  -> Curry_Prelude.OP_Tuple2 t1 t0 -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 t2 t0
nd_C__case_0 x3 x1 x2 x6 s cd cs = case x6 of
  Curry_Prelude.OP_Tuple2 x4 x5 -> let s2 = s
    in s2 `seq` Curry_Prelude.d_C_seq x5 (let s1 = leftSupply s2
                                              s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_apply x2
    x4 s0 cd cs) x5 s1 cd cs)) cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (nd_C__case_0 x3 x1 x2 l
    s cd cs) (nd_C__case_0 x3 x1 x2 r s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> nd_C__case_0
    x3 x1 x2 z s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c (nd_C__case_0 x3 x1 x2 e
    s cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail "State._case_0"
    [show x3, show x1, show x2, show x6] info)
  _ -> failCons cd (consFail "State._case_0" (showCons x6))

