{-# LANGUAGE MagicHash #-}
{-# LANGUAGE ScopedTypeVariables #-}
{-# OPTIONS_GHC -fno-warn-overlapping-patterns #-}

module Rewriting.Curry_Substitution
  ( C_Subst
  , d_C_showSubst
  , nd_C_showSubst
  , d_C_emptySubst
  , nd_C_emptySubst
  , d_C_extendSubst
  , nd_C_extendSubst
  , d_C_listToSubst
  , nd_C_listToSubst
  , d_C_lookupSubst
  , nd_C_lookupSubst
  , d_C_applySubst
  , nd_C_applySubst
  , d_C_applySubstEq
  , nd_C_applySubstEq
  , d_C_applySubstEqs
  , nd_C_applySubstEqs
  , d_C_restrictSubst
  , nd_C_restrictSubst
  , d_C_composeSubst
  , nd_C_composeSubst )
  where

import Basics
import qualified Curry_FiniteMap
import qualified Curry_Function
import qualified Curry_List
import qualified Curry_Maybe
import qualified Curry_Prelude
import qualified Rewriting.Curry_Term


type C_Subst t0 = Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  (Rewriting.Curry_Term.C_Term t0)

d_C_showSubst :: forall t0 . (Curry_Prelude.Curry t0) => (t0 -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_FiniteMap.C_FM Curry_Prelude.C_Int (Rewriting.Curry_Term.C_Term t0)
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_showSubst x1 x2 cd cs = Curry_Prelude.d_OP_plus_plus
  (Curry_Prelude.toCurryString "{") (Curry_Prelude.d_OP_plus_plus
  (Curry_List.d_C_intercalate (Curry_Prelude.toCurryString ",")
  (Curry_Prelude.d_C_map (d_OP_showSubst_dot_showMapping_dot_2 x1)
  (Curry_FiniteMap.d_C_fmToList x2 cd cs) cd cs) cd cs)
  (Curry_Prelude.toCurryString "}") cd cs) cd cs

nd_C_showSubst :: forall t0 . (Curry_Prelude.Curry t0) => Func t0
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_FiniteMap.C_FM
  Curry_Prelude.C_Int (Rewriting.Curry_Term.C_Term t0) -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
nd_C_showSubst x1 x2 s cd cs = let s2 = s
  in s2 `seq` Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString "{")
  (Curry_Prelude.d_OP_plus_plus (Curry_List.d_C_intercalate
  (Curry_Prelude.toCurryString ",") (let s1 = leftSupply s2
                                         s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_map (wrapNX id
  (nd_OP_showSubst_dot_showMapping_dot_2 x1)) (Curry_FiniteMap.nd_C_fmToList x2
  s0 cd cs) s1 cd cs)) cd cs) (Curry_Prelude.toCurryString "}") cd cs) cd cs

d_OP_showSubst_dot_showMapping_dot_2 :: forall t0 . (Curry_Prelude.Curry
  t0) => (t0 -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  (Rewriting.Curry_Term.C_Term t0) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_OP_showSubst_dot_showMapping_dot_2 x1 x2 cd cs = case x2 of
  Curry_Prelude.OP_Tuple2 x3 x4 -> Curry_Prelude.d_OP_plus_plus
    (Rewriting.Curry_Term.d_C_showVarIdx x3 cd cs) (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString " \8614 ") (Curry_Prelude.d_C_apply
    (Rewriting.Curry_Term.d_C_showTerm x1 cd cs) x4 cd cs) cd cs) cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_showSubst_dot_showMapping_dot_2 x1 l cd cs)
    (d_OP_showSubst_dot_showMapping_dot_2 x1 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_showSubst_dot_showMapping_dot_2 x1 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (d_OP_showSubst_dot_showMapping_dot_2 x1 e cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Rewriting.Substitution.showSubst.showMapping.2" [show x1, show x2] info)
  _ -> failCons cd (consFail "Rewriting.Substitution.showSubst.showMapping.2"
    (showCons x2))

nd_OP_showSubst_dot_showMapping_dot_2 :: forall t0 . (Curry_Prelude.Curry
  t0) => Func t0 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Rewriting.Curry_Term.C_Term
  t0) -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
nd_OP_showSubst_dot_showMapping_dot_2 x1 x2 s cd cs = case x2 of
  Curry_Prelude.OP_Tuple2 x3 x4 -> let s2 = s
    in s2 `seq` Curry_Prelude.d_OP_plus_plus
    (Rewriting.Curry_Term.d_C_showVarIdx x3 cd cs) (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString " \8614 ") (let s1 = leftSupply s2
                                                 s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply
    (Rewriting.Curry_Term.nd_C_showTerm x1 s0 cd cs) x4 s1 cd cs)) cd cs) cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (nd_OP_showSubst_dot_showMapping_dot_2 x1 l s cd cs)
    (nd_OP_showSubst_dot_showMapping_dot_2 x1 r s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    nd_OP_showSubst_dot_showMapping_dot_2 x1 z s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (nd_OP_showSubst_dot_showMapping_dot_2 x1 e s cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Rewriting.Substitution.showSubst.showMapping.2" [show x1, show x2] info)
  _ -> failCons cd (consFail "Rewriting.Substitution.showSubst.showMapping.2"
    (showCons x2))

d_C_substOrder :: Cover -> ConstStore -> Curry_Prelude.C_Int -> Cover
  -> ConstStore -> Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
d_C_substOrder cd cs = acceptCs id Curry_Prelude.d_OP_lt

d_C_emptySubst :: forall t0 . (Curry_Prelude.Curry t0) => Cover -> ConstStore
  -> Curry_FiniteMap.C_FM Curry_Prelude.C_Int (Rewriting.Curry_Term.C_Term t0)
d_C_emptySubst cd cs = Curry_FiniteMap.d_C_emptyFM (d_C_substOrder cd cs) cd cs

nd_C_emptySubst :: forall t0 . (Curry_Prelude.Curry t0) => IDSupply -> Cover
  -> ConstStore -> Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  (Rewriting.Curry_Term.C_Term t0)
nd_C_emptySubst s cd cs = let s0 = s
  in s0 `seq` Curry_FiniteMap.nd_C_emptyFM (wrapDX (wrapDX id) (d_C_substOrder
  cd cs)) s0 cd cs

d_C_extendSubst :: forall t0 . (Curry_Prelude.Curry t0) => Cover -> ConstStore
  -> Curry_FiniteMap.C_FM Curry_Prelude.C_Int (Rewriting.Curry_Term.C_Term t0)
  -> Cover -> ConstStore -> Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Rewriting.Curry_Term.C_Term t0 -> Cover -> ConstStore
  -> Curry_FiniteMap.C_FM Curry_Prelude.C_Int (Rewriting.Curry_Term.C_Term t0)
d_C_extendSubst cd cs = acceptCs (acceptCs id) Curry_FiniteMap.d_C_addToFM

nd_C_extendSubst :: forall t0 . (Curry_Prelude.Curry t0) => IDSupply -> Cover
  -> ConstStore -> Func (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  (Rewriting.Curry_Term.C_Term t0)) (Func Curry_Prelude.C_Int (Func
  (Rewriting.Curry_Term.C_Term t0) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  (Rewriting.Curry_Term.C_Term t0))))
nd_C_extendSubst s cd cs = wrapDX (wrapDX (wrapNX id)) (acceptCs (acceptCs id)
  Curry_FiniteMap.nd_C_addToFM)

d_C_listToSubst :: forall t0 . (Curry_Prelude.Curry t0) => Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  (Rewriting.Curry_Term.C_Term t0)) -> Cover -> ConstStore
  -> Curry_FiniteMap.C_FM Curry_Prelude.C_Int (Rewriting.Curry_Term.C_Term t0)
d_C_listToSubst cd cs = Curry_FiniteMap.d_C_listToFM (d_C_substOrder cd cs) cd
  cs

nd_C_listToSubst :: forall t0 . (Curry_Prelude.Curry t0) => IDSupply -> Cover
  -> ConstStore -> Func (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int (Rewriting.Curry_Term.C_Term t0))) (Curry_FiniteMap.C_FM
  Curry_Prelude.C_Int (Rewriting.Curry_Term.C_Term t0))
nd_C_listToSubst s cd cs = let s0 = s
  in s0 `seq` Curry_FiniteMap.nd_C_listToFM (wrapDX (wrapDX id) (d_C_substOrder
  cd cs)) s0 cd cs

d_C_lookupSubst :: forall t0 . (Curry_Prelude.Curry t0) => Cover -> ConstStore
  -> Curry_FiniteMap.C_FM Curry_Prelude.C_Int (Rewriting.Curry_Term.C_Term t0)
  -> Cover -> ConstStore -> Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Curry_Prelude.C_Maybe (Rewriting.Curry_Term.C_Term t0)
d_C_lookupSubst cd cs = acceptCs id Curry_FiniteMap.d_C_lookupFM

nd_C_lookupSubst :: forall t0 . (Curry_Prelude.Curry t0) => IDSupply -> Cover
  -> ConstStore -> Func (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  (Rewriting.Curry_Term.C_Term t0)) (Func Curry_Prelude.C_Int
  (Curry_Prelude.C_Maybe (Rewriting.Curry_Term.C_Term t0)))
nd_C_lookupSubst s cd cs = wrapDX (wrapNX id) (acceptCs id
  Curry_FiniteMap.nd_C_lookupFM)

d_C_applySubst :: forall t0 . (Curry_Prelude.Curry t0) => Curry_FiniteMap.C_FM
  Curry_Prelude.C_Int (Rewriting.Curry_Term.C_Term t0)
  -> Rewriting.Curry_Term.C_Term t0 -> Cover -> ConstStore
  -> Rewriting.Curry_Term.C_Term t0
d_C_applySubst x1 x2 cd cs = case x2 of
  Rewriting.Curry_Term.C_TermVar x3 -> Curry_Maybe.d_C_fromMaybe x2
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply (d_C_lookupSubst cd cs) x1
    cd cs) x3 cd cs) cd cs
  Rewriting.Curry_Term.C_TermCons x4 x5 -> Rewriting.Curry_Term.C_TermCons x4
    (Curry_Prelude.d_C_map (d_C_applySubst x1) x5 cd cs)
  Rewriting.Curry_Term.Choice_C_Term d i l r -> narrow d i (d_C_applySubst x1 l
    cd cs) (d_C_applySubst x1 r cd cs)
  Rewriting.Curry_Term.Choices_C_Term d i xs -> narrows cs d i (\z ->
    d_C_applySubst x1 z cd cs) xs
  Rewriting.Curry_Term.Guard_C_Term d c e -> guardCons d c (d_C_applySubst x1 e
    cd $! addCs c cs)
  Rewriting.Curry_Term.Fail_C_Term d info -> failCons d (traceFail
    "Rewriting.Substitution.applySubst" [show x1, show x2] info)
  _ -> failCons cd (consFail "Rewriting.Substitution.applySubst" (showCons x2))

nd_C_applySubst :: forall t0 . (Curry_Prelude.Curry t0) => Curry_FiniteMap.C_FM
  Curry_Prelude.C_Int (Rewriting.Curry_Term.C_Term t0)
  -> Rewriting.Curry_Term.C_Term t0 -> IDSupply -> Cover -> ConstStore
  -> Rewriting.Curry_Term.C_Term t0
nd_C_applySubst x1 x2 s cd cs = case x2 of
  Rewriting.Curry_Term.C_TermVar x3 -> let s4 = s
    in s4 `seq` Curry_Maybe.d_C_fromMaybe x2 (let s3 = leftSupply s4
                                                  s2 = rightSupply s4
    in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_apply (let s1 = leftSupply s2
                                                        s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (nd_C_lookupSubst s0 cd cs)
    x1 s1 cd cs)) x3 s3 cd cs)) cd cs
  Rewriting.Curry_Term.C_TermCons x4 x5 -> let s0 = s
    in s0 `seq` Rewriting.Curry_Term.C_TermCons x4 (Curry_Prelude.nd_C_map
    (wrapNX id (nd_C_applySubst x1)) x5 s0 cd cs)
  Rewriting.Curry_Term.Choice_C_Term d i l r -> narrow d i (nd_C_applySubst x1 l
    s cd cs) (nd_C_applySubst x1 r s cd cs)
  Rewriting.Curry_Term.Choices_C_Term d i xs -> narrows cs d i (\z ->
    nd_C_applySubst x1 z s cd cs) xs
  Rewriting.Curry_Term.Guard_C_Term d c e -> guardCons d c (nd_C_applySubst x1 e
    s cd $! addCs c cs)
  Rewriting.Curry_Term.Fail_C_Term d info -> failCons d (traceFail
    "Rewriting.Substitution.applySubst" [show x1, show x2] info)
  _ -> failCons cd (consFail "Rewriting.Substitution.applySubst" (showCons x2))

d_C_applySubstEq :: forall t0 . (Curry_Prelude.Curry t0) => Curry_FiniteMap.C_FM
  Curry_Prelude.C_Int (Rewriting.Curry_Term.C_Term t0) -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (Rewriting.Curry_Term.C_Term t0)
  (Rewriting.Curry_Term.C_Term t0) -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (Rewriting.Curry_Term.C_Term t0)
  (Rewriting.Curry_Term.C_Term t0)
d_C_applySubstEq x1 cd cs = Curry_Function.d_C_both (d_C_applySubst x1)

nd_C_applySubstEq :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_FiniteMap.C_FM Curry_Prelude.C_Int (Rewriting.Curry_Term.C_Term
  t0) -> IDSupply -> Cover -> ConstStore -> Func (Curry_Prelude.OP_Tuple2
  (Rewriting.Curry_Term.C_Term t0) (Rewriting.Curry_Term.C_Term t0))
  (Curry_Prelude.OP_Tuple2 (Rewriting.Curry_Term.C_Term t0)
  (Rewriting.Curry_Term.C_Term t0))
nd_C_applySubstEq x1 s cd cs = wrapNX id (Curry_Function.nd_C_both (wrapNX id
  (nd_C_applySubst x1)))

d_C_applySubstEqs :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_FiniteMap.C_FM Curry_Prelude.C_Int (Rewriting.Curry_Term.C_Term
  t0) -> Cover -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Rewriting.Curry_Term.C_Term t0) (Rewriting.Curry_Term.C_Term t0)) -> Cover
  -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Rewriting.Curry_Term.C_Term t0) (Rewriting.Curry_Term.C_Term t0))
d_C_applySubstEqs x1 cd cs = Curry_Prelude.d_C_map (d_C_applySubstEq x1 cd cs)

nd_C_applySubstEqs :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_FiniteMap.C_FM Curry_Prelude.C_Int (Rewriting.Curry_Term.C_Term
  t0) -> IDSupply -> Cover -> ConstStore -> Func (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Rewriting.Curry_Term.C_Term t0)
  (Rewriting.Curry_Term.C_Term t0))) (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Rewriting.Curry_Term.C_Term t0)
  (Rewriting.Curry_Term.C_Term t0)))
nd_C_applySubstEqs x1 s cd cs = let s0 = s
  in s0 `seq` wrapNX id (Curry_Prelude.nd_C_map (nd_C_applySubstEq x1 s0 cd cs))

d_C_restrictSubst :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_FiniteMap.C_FM Curry_Prelude.C_Int (Rewriting.Curry_Term.C_Term
  t0) -> Curry_Prelude.OP_List Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Curry_FiniteMap.C_FM Curry_Prelude.C_Int (Rewriting.Curry_Term.C_Term t0)
d_C_restrictSubst x1 x2 cd cs = Curry_Prelude.d_C_apply (d_C_listToSubst cd cs)
  (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_concatMap
  (d_OP_restrictSubst_dot_uscore_hash_lambda1 x1) cd cs) x2 cd cs) cd cs

nd_C_restrictSubst :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_FiniteMap.C_FM Curry_Prelude.C_Int (Rewriting.Curry_Term.C_Term
  t0) -> Curry_Prelude.OP_List Curry_Prelude.C_Int -> IDSupply -> Cover
  -> ConstStore -> Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  (Rewriting.Curry_Term.C_Term t0)
nd_C_restrictSubst x1 x2 s cd cs = let s5 = s
  in s5 `seq` (let s4 = leftSupply s5
                   s6 = rightSupply s5
                   s0 = leftSupply s6
                   s3 = rightSupply s6
  in s4 `seq` (s6 `seq` (s0 `seq` (s3 `seq` Curry_Prelude.nd_C_apply
  (nd_C_listToSubst s0 cd cs) (let s2 = leftSupply s3
                                   s1 = rightSupply s3
  in s2 `seq` (s1 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_concatMap
  (wrapNX id (nd_OP_restrictSubst_dot_uscore_hash_lambda1 x1)) s1 cd cs) x2 s2
  cd cs)) s4 cd cs))))

d_OP_restrictSubst_dot_uscore_hash_lambda1 :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_FiniteMap.C_FM Curry_Prelude.C_Int (Rewriting.Curry_Term.C_Term
  t0) -> Curry_Prelude.C_Int -> Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Rewriting.Curry_Term.C_Term t0))
d_OP_restrictSubst_dot_uscore_hash_lambda1 x1 x2 cd cs = Curry_Prelude.d_C_foldr
  (acceptCs id
  (d_OP_restrictSubst_dot_uscore_hash_lambda1_dot_uscore_hash_lambda4 x2))
  Curry_Prelude.OP_List (Curry_Prelude.OP_Cons (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_C_apply (d_C_lookupSubst cd cs) x1 cd cs) x2 cd cs)
  Curry_Prelude.OP_List) cd cs

nd_OP_restrictSubst_dot_uscore_hash_lambda1 :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_FiniteMap.C_FM Curry_Prelude.C_Int (Rewriting.Curry_Term.C_Term
  t0) -> Curry_Prelude.C_Int -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  (Rewriting.Curry_Term.C_Term t0))
nd_OP_restrictSubst_dot_uscore_hash_lambda1 x1 x2 s cd cs = let s6 = s
  in s6 `seq` (let s5 = leftSupply s6
                   s4 = rightSupply s6
  in s5 `seq` (s4 `seq` Curry_Prelude.nd_C_foldr (wrapDX (wrapDX id) (acceptCs
  id (d_OP_restrictSubst_dot_uscore_hash_lambda1_dot_uscore_hash_lambda4 x2)))
  Curry_Prelude.OP_List (Curry_Prelude.OP_Cons (let s3 = leftSupply s4
                                                    s2 = rightSupply s4
  in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_apply (let s1 = leftSupply s2
                                                      s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (nd_C_lookupSubst s0 cd cs) x1
  s1 cd cs)) x2 s3 cd cs)) Curry_Prelude.OP_List) s5 cd cs))

d_OP_restrictSubst_dot_uscore_hash_lambda1_dot_uscore_hash_lambda4 :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.C_Int -> Curry_Prelude.C_Maybe
  (Rewriting.Curry_Term.C_Term t0) -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Rewriting.Curry_Term.C_Term t0))
  -> Cover -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int (Rewriting.Curry_Term.C_Term t0))
d_OP_restrictSubst_dot_uscore_hash_lambda1_dot_uscore_hash_lambda4 x1 x2 x3 cd cs =
  case x2 of
  Curry_Prelude.C_Just x4 -> Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 x1
    x4) x3
  Curry_Prelude.C_Nothing -> x3
  Curry_Prelude.Choice_C_Maybe d i l r -> narrow d i
    (d_OP_restrictSubst_dot_uscore_hash_lambda1_dot_uscore_hash_lambda4 x1 l x3
    cd cs) (d_OP_restrictSubst_dot_uscore_hash_lambda1_dot_uscore_hash_lambda4
    x1 r x3 cd cs)
  Curry_Prelude.Choices_C_Maybe d i xs -> narrows cs d i (\z ->
    d_OP_restrictSubst_dot_uscore_hash_lambda1_dot_uscore_hash_lambda4 x1 z x3
    cd cs) xs
  Curry_Prelude.Guard_C_Maybe d c e -> guardCons d c
    (d_OP_restrictSubst_dot_uscore_hash_lambda1_dot_uscore_hash_lambda4 x1 e x3
    cd $! addCs c cs)
  Curry_Prelude.Fail_C_Maybe d info -> failCons d (traceFail
    "Rewriting.Substitution.restrictSubst._#lambda1._#lambda4" [show x1, show x2
    , show x3] info)
  _ -> failCons cd (consFail
    "Rewriting.Substitution.restrictSubst._#lambda1._#lambda4" (showCons x2))

d_C_composeSubst :: forall t0 . (Curry_Prelude.Curry t0) => Curry_FiniteMap.C_FM
  Curry_Prelude.C_Int (Rewriting.Curry_Term.C_Term t0) -> Curry_FiniteMap.C_FM
  Curry_Prelude.C_Int (Rewriting.Curry_Term.C_Term t0) -> Cover -> ConstStore
  -> Curry_FiniteMap.C_FM Curry_Prelude.C_Int (Rewriting.Curry_Term.C_Term t0)
d_C_composeSubst x1 x2 cd cs = Curry_FiniteMap.d_C_plusFM x1
  (Curry_FiniteMap.d_C_mapFM (acceptCs id
  (d_OP_composeSubst_dot_uscore_hash_lambda6 x1)) x2 cd cs) cd cs

nd_C_composeSubst :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_FiniteMap.C_FM Curry_Prelude.C_Int (Rewriting.Curry_Term.C_Term
  t0) -> Curry_FiniteMap.C_FM Curry_Prelude.C_Int (Rewriting.Curry_Term.C_Term
  t0) -> IDSupply -> Cover -> ConstStore -> Curry_FiniteMap.C_FM
  Curry_Prelude.C_Int (Rewriting.Curry_Term.C_Term t0)
nd_C_composeSubst x1 x2 s cd cs = let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_FiniteMap.nd_C_plusFM x1
  (Curry_FiniteMap.nd_C_mapFM (wrapDX (wrapNX id) (acceptCs id
  (nd_OP_composeSubst_dot_uscore_hash_lambda6 x1))) x2 s0 cd cs) s1 cd cs))

d_OP_composeSubst_dot_uscore_hash_lambda6 :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_FiniteMap.C_FM Curry_Prelude.C_Int (Rewriting.Curry_Term.C_Term
  t0) -> Curry_Prelude.C_Int -> Rewriting.Curry_Term.C_Term t0 -> Cover
  -> ConstStore -> Rewriting.Curry_Term.C_Term t0
d_OP_composeSubst_dot_uscore_hash_lambda6 x1 x2 x3 cd cs = d_C_applySubst x1 x3
  cd cs

nd_OP_composeSubst_dot_uscore_hash_lambda6 :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_FiniteMap.C_FM Curry_Prelude.C_Int (Rewriting.Curry_Term.C_Term
  t0) -> Curry_Prelude.C_Int -> Rewriting.Curry_Term.C_Term t0 -> IDSupply
  -> Cover -> ConstStore -> Rewriting.Curry_Term.C_Term t0
nd_OP_composeSubst_dot_uscore_hash_lambda6 x1 x2 x3 s cd cs = let s0 = s
  in s0 `seq` nd_C_applySubst x1 x3 s0 cd cs

